define('dummy/controllers/add', ['exports', 'ember', 'ember-cli-simple-validation/mixins/validate'], function (exports, Ember, validate) {

    'use strict';

    var customFunc = function customFunc() {
        var value = this.get("model.rando");
        return value === "1";
    };

    exports['default'] = Ember['default'].Controller.extend(validate.ValidationMixin, {
        nameValidation: validate.validate("model.name"),
        zipcodeValidation: validate.validate("model.zipcode", /\d{5}/),
        emailValidation: validate.validate("model.email", /\S+@\S+\.\S+/),
        randoValidation: validate.validate("model.rando", customFunc),
        radeoValidation: validate.validate("model.radeo"),
        tosValidation: validate.validate("model.tos"),
        thingValidation: validate.validate("model.thing"),
        things: [{ id: 1 }, { id: 2 }, { id: 3 }, { id: 4 }],
        actions: {
            save: function save() {
                this.set("submitted", true);
                if (this.get("valid")) {
                    this.transitionToRoute("success");
                }
            }
        }
    });

});