define('dummy/controllers/many', ['exports', 'ember', 'ember-cli-simple-validation/mixins/validate'], function (exports, Ember, validate) {

    'use strict';

    var longEnough = function longEnough(value) {
        return value.trim().length > 3;
    };

    var ManyController = Ember['default'].ArrayController.extend(validate.ValidationMixin, {
        basic: validate.validateEach("name"),
        len: validate.validateEach("name", longEnough),
        actions: {
            save: function save() {
                this.set("submitted", true);
                if (this.get("valid")) {
                    this.transitionToRoute("success");
                }
            }
        }
    });

    exports['default'] = ManyController;

});