define('dummy/controllers/multi', ['exports', 'ember', 'dummy/models/person', 'ember-cli-simple-validation/mixins/validate'], function (exports, Ember, Person, validate) {

    'use strict';

    var isEven = function isEven() {
        var index = arguments[3];
        var value = this.get("model").objectAt(index).get("rando");
        var number = parseInt(value, 10);
        return number && number % 2 === 0;
    };

    var MultiController = Ember['default'].ArrayController.extend(validate.ValidationMixin, {
        name: validate.validateEach("name"),
        rando: validate.validateEach("rando", isEven),
        actions: {
            add: function add() {
                this.get("model").pushObject(Person['default'].create());
            },
            remove: function remove(person) {
                this.get("model").removeObject(person);
            },
            save: function save() {
                this.set("submitted", true);
                if (this.get("valid")) {
                    this.transitionToRoute("success");
                }
            }
        }
    });

    exports['default'] = MultiController;

});