define('dummy/tests/acceptance/many-array-single-prop-validation-test', ['ember', 'dummy/tests/helpers/start-app', 'qunit'], function (Ember, startApp, qunit) {

  'use strict';

  var application;

  var SAVE_BUTTON = "button.save";
  var VALID_NAME = "123";
  var VALID_NAME_AND_LEN = "1234";

  var FIRST_LEN_ERROR_FIELD = ".name-parent-div:eq(0) span.len";
  var FIRST_BASIC_ERROR_FIELD = ".name-parent-div:eq(0) span.basic";
  var FIRST_NAME_INPUT = ".name-parent-div:eq(0) input";

  var SECOND_LEN_ERROR_FIELD = ".name-parent-div:eq(1) span.len";
  var SECOND_BASIC_ERROR_FIELD = ".name-parent-div:eq(1) span.basic";
  var SECOND_NAME_INPUT = ".name-parent-div:eq(1) input";

  qunit.module("Acceptance: Many Array Single Prop Validation", {
    setup: function setup() {
      application = startApp['default']();
    },
    teardown: function teardown() {
      Ember['default'].run(application, "destroy");
    }
  });

  qunit.test("validateEach will pull named validators when supplied", function (assert) {
    visit("/many");
    andThen(function () {
      assert.equal(find(FIRST_LEN_ERROR_FIELD).hasClass("hidden"), true);
      assert.equal(find(SECOND_LEN_ERROR_FIELD).hasClass("hidden"), true);
      assert.equal(find(FIRST_BASIC_ERROR_FIELD).hasClass("hidden"), true);
      assert.equal(find(SECOND_BASIC_ERROR_FIELD).hasClass("hidden"), true);
    });
    click(SAVE_BUTTON);
    andThen(function () {
      assert.equal(find(FIRST_LEN_ERROR_FIELD).hasClass("hidden"), false);
      assert.equal(find(SECOND_LEN_ERROR_FIELD).hasClass("hidden"), false);
      assert.equal(find(FIRST_BASIC_ERROR_FIELD).hasClass("hidden"), false);
      assert.equal(find(SECOND_BASIC_ERROR_FIELD).hasClass("hidden"), false);
    });
    fillIn(SECOND_NAME_INPUT, VALID_NAME);
    andThen(function () {
      assert.equal(find(FIRST_LEN_ERROR_FIELD).hasClass("hidden"), false);
      assert.equal(find(SECOND_LEN_ERROR_FIELD).hasClass("hidden"), false);
      assert.equal(find(FIRST_BASIC_ERROR_FIELD).hasClass("hidden"), false);
      assert.equal(find(SECOND_BASIC_ERROR_FIELD).hasClass("hidden"), true);
    });
    fillIn(FIRST_NAME_INPUT, VALID_NAME);
    andThen(function () {
      assert.equal(find(FIRST_LEN_ERROR_FIELD).hasClass("hidden"), false);
      assert.equal(find(SECOND_LEN_ERROR_FIELD).hasClass("hidden"), false);
      assert.equal(find(FIRST_BASIC_ERROR_FIELD).hasClass("hidden"), true);
      assert.equal(find(SECOND_BASIC_ERROR_FIELD).hasClass("hidden"), true);
    });
    fillIn(SECOND_NAME_INPUT, VALID_NAME_AND_LEN);
    andThen(function () {
      assert.equal(find(FIRST_LEN_ERROR_FIELD).hasClass("hidden"), false);
      assert.equal(find(SECOND_LEN_ERROR_FIELD).hasClass("hidden"), true);
      assert.equal(find(FIRST_BASIC_ERROR_FIELD).hasClass("hidden"), true);
      assert.equal(find(SECOND_BASIC_ERROR_FIELD).hasClass("hidden"), true);
    });
    fillIn(FIRST_NAME_INPUT, VALID_NAME_AND_LEN);
    andThen(function () {
      assert.equal(find(FIRST_LEN_ERROR_FIELD).hasClass("hidden"), true);
      assert.equal(find(SECOND_LEN_ERROR_FIELD).hasClass("hidden"), true);
      assert.equal(find(FIRST_BASIC_ERROR_FIELD).hasClass("hidden"), true);
      assert.equal(find(SECOND_BASIC_ERROR_FIELD).hasClass("hidden"), true);
    });
    click(SAVE_BUTTON);
    andThen(function () {
      assert.equal(currentURL(), "/success");
    });
  });

});