/* jshint ignore:start */

/* jshint ignore:end */

define('dummy/app', ['exports', 'ember', 'ember/resolver', 'ember/load-initializers', 'dummy/config/environment'], function (exports, Ember, Resolver, loadInitializers, config) {

  'use strict';

  Ember['default'].MODEL_FACTORY_INJECTIONS = true;

  var App = Ember['default'].Application.extend({
    modulePrefix: config['default'].modulePrefix,
    podModulePrefix: config['default'].podModulePrefix,
    Resolver: Resolver['default']
  });

  loadInitializers['default'](App, config['default'].modulePrefix);

  exports['default'] = App;

});
define('dummy/components/radio-button', ['exports', 'ember'], function (exports, Ember) {

    'use strict';

    exports['default'] = Ember['default'].Component.extend({
        tagName: "input",
        type: "radio",
        attributeBindings: ["id", "checked", "name", "type", "value"],
        checked: (function () {
            return this.get("groupValue") === this.get("value");
        }).property("groupValue", "value"),
        change: function change(event) {
            var groupValue = this.get("groupValue");
            var value = event.target.checked ? this.get("value") : undefined;
            this.set("groupValue", value);
            if (groupValue !== value) {
                Ember['default'].run.schedule("actions", this, function () {
                    this.sendAction("changed", this.get("value"));
                });
            }
        }
    });

});
define('dummy/components/validation-error-field', ['exports', 'ember', 'ember-cli-simple-validation/components/validation-error-field'], function (exports, Ember, ValidationErrorField) {

	'use strict';

	exports['default'] = ValidationErrorField['default'];

});
define('dummy/controllers/add', ['exports', 'ember', 'ember-cli-simple-validation/mixins/validate'], function (exports, Ember, validate) {

    'use strict';

    var customFunc = function customFunc() {
        var value = this.get("model.rando");
        return value === "1";
    };

    exports['default'] = Ember['default'].Controller.extend(validate.ValidationMixin, {
        nameValidation: validate.validate("model.name"),
        zipcodeValidation: validate.validate("model.zipcode", /\d{5}/),
        emailValidation: validate.validate("model.email", /\S+@\S+\.\S+/),
        randoValidation: validate.validate("model.rando", customFunc),
        radeoValidation: validate.validate("model.radeo"),
        tosValidation: validate.validate("model.tos"),
        thingValidation: validate.validate("model.thing"),
        things: [{ id: 1 }, { id: 2 }, { id: 3 }, { id: 4 }],
        actions: {
            save: function save() {
                this.set("submitted", true);
                if (this.get("valid")) {
                    this.transitionToRoute("success");
                }
            }
        }
    });

});
define('dummy/controllers/edit', ['exports', 'ember', 'ember-cli-simple-validation/mixins/validate'], function (exports, Ember, validate) {

    'use strict';

    exports['default'] = Ember['default'].Controller.extend(validate.ValidationMixin, {
        nameValidation: validate.validate("model.name"),
        zipcodeValidation: validate.validate("model.zipcode", /\d{5}/),
        emailValidation: validate.validate("model.email", /\S+@\S+\.\S+/),
        actions: {
            save: function save() {
                this.set("submitted", true);
                if (this.get("valid")) {
                    this.transitionToRoute("success");
                }
            }
        }
    });

});
define('dummy/controllers/many', ['exports', 'ember', 'ember-cli-simple-validation/mixins/validate'], function (exports, Ember, validate) {

    'use strict';

    var longEnough = function longEnough(value) {
        return value.trim().length > 3;
    };

    var ManyController = Ember['default'].ArrayController.extend(validate.ValidationMixin, {
        basic: validate.validateEach("name"),
        len: validate.validateEach("name", longEnough),
        actions: {
            save: function save() {
                this.set("submitted", true);
                if (this.get("valid")) {
                    this.transitionToRoute("success");
                }
            }
        }
    });

    exports['default'] = ManyController;

});
define('dummy/controllers/multi', ['exports', 'ember', 'dummy/models/person', 'ember-cli-simple-validation/mixins/validate'], function (exports, Ember, Person, validate) {

    'use strict';

    var isEven = function isEven() {
        var index = arguments[3];
        var value = this.get("model").objectAt(index).get("rando");
        var number = parseInt(value, 10);
        return number && number % 2 === 0;
    };

    var MultiController = Ember['default'].ArrayController.extend(validate.ValidationMixin, {
        name: validate.validateEach("name"),
        rando: validate.validateEach("rando", isEven),
        actions: {
            add: function add() {
                this.get("model").pushObject(Person['default'].create());
            },
            remove: function remove(person) {
                this.get("model").removeObject(person);
            },
            save: function save() {
                this.set("submitted", true);
                if (this.get("valid")) {
                    this.transitionToRoute("success");
                }
            }
        }
    });

    exports['default'] = MultiController;

});
define('dummy/controllers/other', ['exports', 'ember', 'dummy/models/other', 'ember-cli-simple-validation/mixins/validate'], function (exports, Ember, Other, validate) {

    'use strict';

    var OtherController = Ember['default'].ArrayController.extend(validate.ValidationMixin, {
        tos: validate.validateEach("tos"),
        displayName: validate.validateEach("displayName"),
        actions: {
            add: function add() {
                this.get("model").pushObject(Other['default'].create());
            },
            remove: function remove(other) {
                this.get("model").removeObject(other);
            },
            save: function save() {
                this.set("submitted", true);
                if (this.get("valid")) {
                    this.transitionToRoute("success");
                }
            }
        }
    });

    exports['default'] = OtherController;

});
define('dummy/ember-cli-simple-validation/tests/modules/ember-cli-simple-validation/components/validation-error-field.jshint', function () {

  'use strict';

  module("JSHint - modules/ember-cli-simple-validation/components");
  test("modules/ember-cli-simple-validation/components/validation-error-field.js should pass jshint", function () {
    ok(true, "modules/ember-cli-simple-validation/components/validation-error-field.js should pass jshint.");
  });

});
define('dummy/ember-cli-simple-validation/tests/modules/ember-cli-simple-validation/mixins/validate.jshint', function () {

  'use strict';

  module("JSHint - modules/ember-cli-simple-validation/mixins");
  test("modules/ember-cli-simple-validation/mixins/validate.js should pass jshint", function () {
    ok(true, "modules/ember-cli-simple-validation/mixins/validate.js should pass jshint.");
  });

});
define('dummy/initializers/app-version', ['exports', 'dummy/config/environment', 'ember'], function (exports, config, Ember) {

  'use strict';

  var classify = Ember['default'].String.classify;

  exports['default'] = {
    name: "App Version",
    initialize: function initialize(container, application) {
      var appName = classify(application.toString());
      Ember['default'].libraries.register(appName, config['default'].APP.version);
    }
  };

});
define('dummy/initializers/ember-cli-simple-store', ['exports', 'ember-cli-simple-store/initializers/ember-cli-simple-store'], function (exports, initializer) {

    'use strict';

    exports['default'] = {
        name: "store",
        initialize: initializer['default']
    };

});
define('dummy/initializers/export-application-global', ['exports', 'ember', 'dummy/config/environment'], function (exports, Ember, config) {

  'use strict';

  exports.initialize = initialize;

  function initialize(container, application) {
    var classifiedName = Ember['default'].String.classify(config['default'].modulePrefix);

    if (config['default'].exportApplicationGlobal && !window[classifiedName]) {
      window[classifiedName] = application;
    }
  }

  ;

  exports['default'] = {
    name: "export-application-global",

    initialize: initialize
  };

});
define('dummy/models/many', ['exports', 'ember-cli-simple-store/model'], function (exports, model) {

    'use strict';

    exports['default'] = model.Model.extend({
        name: model.attr()
    });

});
define('dummy/models/other', ['exports', 'ember-cli-simple-store/model'], function (exports, model) {

    'use strict';

    exports['default'] = model.Model.extend({
        displayName: model.attr(),
        tos: model.attr()
    });

});
define('dummy/models/person', ['exports', 'ember-cli-simple-store/model'], function (exports, model) {

    'use strict';

    exports['default'] = model.Model.extend({
        name: model.attr(),
        zipcode: model.attr(),
        email: model.attr(),
        rando: model.attr(),
        radeo: model.attr(),
        thing: model.attr(),
        tos: model.attr()
    });

});
define('dummy/router', ['exports', 'ember', 'dummy/config/environment'], function (exports, Ember, config) {

    'use strict';

    var Router = Ember['default'].Router.extend({
        location: config['default'].locationType
    });

    Router.map(function () {
        this.route("add", { path: "/" });
        this.route("edit", { path: "/edit" });
        this.route("success", { path: "/success" });
        this.route("multi", { path: "/multi" });
        this.route("many", { path: "/many" });
        this.route("other", { path: "/other" });
    });

    exports['default'] = Router;

});
define('dummy/routes/add', ['exports', 'ember', 'dummy/models/person'], function (exports, Ember, Person) {

    'use strict';

    exports['default'] = Ember['default'].Route.extend({
        model: function model() {
            return Person['default'].create();
        }
    });

});
define('dummy/routes/edit', ['exports', 'ember', 'dummy/models/person'], function (exports, Ember, Person) {

    'use strict';

    exports['default'] = Ember['default'].Route.extend({
        model: function model() {
            var store = this.get("store");
            store.push("person", {
                name: "toran",
                zipcode: "52601",
                email: "toranb@gmail.com"
            });
            return store.findOne("person");
        }
    });

});
define('dummy/routes/many', ['exports', 'ember', 'dummy/models/many'], function (exports, Ember, Many) {

    'use strict';

    var ManyRoute = Ember['default'].Route.extend({
        model: function model() {
            var one = Many['default'].create();
            var two = Many['default'].create();
            return [one, two];
        }
    });

    exports['default'] = ManyRoute;

});
define('dummy/routes/multi', ['exports', 'ember', 'dummy/models/person'], function (exports, Ember, Person) {

    'use strict';

    var MultiRoute = Ember['default'].Route.extend({
        model: function model() {
            var one = Person['default'].create();
            var two = Person['default'].create();
            var three = Person['default'].create();
            return [one, two, three];
        }
    });

    exports['default'] = MultiRoute;

});
define('dummy/routes/other', ['exports', 'ember', 'dummy/models/other'], function (exports, Ember, Other) {

    'use strict';

    var OtherRoute = Ember['default'].Route.extend({
        model: function model() {
            var one = Other['default'].create();
            var two = Other['default'].create();
            var three = Other['default'].create();
            return [one, two, three];
        }
    });

    exports['default'] = OtherRoute;

});
define('dummy/templates/add', ['exports'], function (exports) {

  'use strict';

  exports['default'] = Ember.HTMLBars.template((function() {
    var child0 = (function() {
      return {
        isHTMLBars: true,
        revision: "Ember@1.11.0-beta.5",
        blockParams: 0,
        cachedFragment: null,
        hasRendered: false,
        build: function build(dom) {
          var el0 = dom.createDocumentFragment();
          var el1 = dom.createTextNode("invalid name");
          dom.appendChild(el0, el1);
          return el0;
        },
        render: function render(context, env, contextualElement) {
          var dom = env.dom;
          dom.detectNamespace(contextualElement);
          var fragment;
          if (env.useFragmentCache && dom.canClone) {
            if (this.cachedFragment === null) {
              fragment = this.build(dom);
              if (this.hasRendered) {
                this.cachedFragment = fragment;
              } else {
                this.hasRendered = true;
              }
            }
            if (this.cachedFragment) {
              fragment = dom.cloneNode(this.cachedFragment, true);
            }
          } else {
            fragment = this.build(dom);
          }
          return fragment;
        }
      };
    }());
    var child1 = (function() {
      return {
        isHTMLBars: true,
        revision: "Ember@1.11.0-beta.5",
        blockParams: 0,
        cachedFragment: null,
        hasRendered: false,
        build: function build(dom) {
          var el0 = dom.createDocumentFragment();
          var el1 = dom.createTextNode("invalid zipcode");
          dom.appendChild(el0, el1);
          return el0;
        },
        render: function render(context, env, contextualElement) {
          var dom = env.dom;
          dom.detectNamespace(contextualElement);
          var fragment;
          if (env.useFragmentCache && dom.canClone) {
            if (this.cachedFragment === null) {
              fragment = this.build(dom);
              if (this.hasRendered) {
                this.cachedFragment = fragment;
              } else {
                this.hasRendered = true;
              }
            }
            if (this.cachedFragment) {
              fragment = dom.cloneNode(this.cachedFragment, true);
            }
          } else {
            fragment = this.build(dom);
          }
          return fragment;
        }
      };
    }());
    var child2 = (function() {
      return {
        isHTMLBars: true,
        revision: "Ember@1.11.0-beta.5",
        blockParams: 0,
        cachedFragment: null,
        hasRendered: false,
        build: function build(dom) {
          var el0 = dom.createDocumentFragment();
          var el1 = dom.createTextNode("invalid email");
          dom.appendChild(el0, el1);
          return el0;
        },
        render: function render(context, env, contextualElement) {
          var dom = env.dom;
          dom.detectNamespace(contextualElement);
          var fragment;
          if (env.useFragmentCache && dom.canClone) {
            if (this.cachedFragment === null) {
              fragment = this.build(dom);
              if (this.hasRendered) {
                this.cachedFragment = fragment;
              } else {
                this.hasRendered = true;
              }
            }
            if (this.cachedFragment) {
              fragment = dom.cloneNode(this.cachedFragment, true);
            }
          } else {
            fragment = this.build(dom);
          }
          return fragment;
        }
      };
    }());
    var child3 = (function() {
      return {
        isHTMLBars: true,
        revision: "Ember@1.11.0-beta.5",
        blockParams: 0,
        cachedFragment: null,
        hasRendered: false,
        build: function build(dom) {
          var el0 = dom.createDocumentFragment();
          var el1 = dom.createTextNode("invalid rando");
          dom.appendChild(el0, el1);
          return el0;
        },
        render: function render(context, env, contextualElement) {
          var dom = env.dom;
          dom.detectNamespace(contextualElement);
          var fragment;
          if (env.useFragmentCache && dom.canClone) {
            if (this.cachedFragment === null) {
              fragment = this.build(dom);
              if (this.hasRendered) {
                this.cachedFragment = fragment;
              } else {
                this.hasRendered = true;
              }
            }
            if (this.cachedFragment) {
              fragment = dom.cloneNode(this.cachedFragment, true);
            }
          } else {
            fragment = this.build(dom);
          }
          return fragment;
        }
      };
    }());
    var child4 = (function() {
      return {
        isHTMLBars: true,
        revision: "Ember@1.11.0-beta.5",
        blockParams: 0,
        cachedFragment: null,
        hasRendered: false,
        build: function build(dom) {
          var el0 = dom.createDocumentFragment();
          var el1 = dom.createTextNode("invalid radeo");
          dom.appendChild(el0, el1);
          return el0;
        },
        render: function render(context, env, contextualElement) {
          var dom = env.dom;
          dom.detectNamespace(contextualElement);
          var fragment;
          if (env.useFragmentCache && dom.canClone) {
            if (this.cachedFragment === null) {
              fragment = this.build(dom);
              if (this.hasRendered) {
                this.cachedFragment = fragment;
              } else {
                this.hasRendered = true;
              }
            }
            if (this.cachedFragment) {
              fragment = dom.cloneNode(this.cachedFragment, true);
            }
          } else {
            fragment = this.build(dom);
          }
          return fragment;
        }
      };
    }());
    var child5 = (function() {
      return {
        isHTMLBars: true,
        revision: "Ember@1.11.0-beta.5",
        blockParams: 0,
        cachedFragment: null,
        hasRendered: false,
        build: function build(dom) {
          var el0 = dom.createDocumentFragment();
          var el1 = dom.createTextNode("invalid thing");
          dom.appendChild(el0, el1);
          return el0;
        },
        render: function render(context, env, contextualElement) {
          var dom = env.dom;
          dom.detectNamespace(contextualElement);
          var fragment;
          if (env.useFragmentCache && dom.canClone) {
            if (this.cachedFragment === null) {
              fragment = this.build(dom);
              if (this.hasRendered) {
                this.cachedFragment = fragment;
              } else {
                this.hasRendered = true;
              }
            }
            if (this.cachedFragment) {
              fragment = dom.cloneNode(this.cachedFragment, true);
            }
          } else {
            fragment = this.build(dom);
          }
          return fragment;
        }
      };
    }());
    var child6 = (function() {
      return {
        isHTMLBars: true,
        revision: "Ember@1.11.0-beta.5",
        blockParams: 0,
        cachedFragment: null,
        hasRendered: false,
        build: function build(dom) {
          var el0 = dom.createDocumentFragment();
          var el1 = dom.createTextNode("invalid tos");
          dom.appendChild(el0, el1);
          return el0;
        },
        render: function render(context, env, contextualElement) {
          var dom = env.dom;
          dom.detectNamespace(contextualElement);
          var fragment;
          if (env.useFragmentCache && dom.canClone) {
            if (this.cachedFragment === null) {
              fragment = this.build(dom);
              if (this.hasRendered) {
                this.cachedFragment = fragment;
              } else {
                this.hasRendered = true;
              }
            }
            if (this.cachedFragment) {
              fragment = dom.cloneNode(this.cachedFragment, true);
            }
          } else {
            fragment = this.build(dom);
          }
          return fragment;
        }
      };
    }());
    return {
      isHTMLBars: true,
      revision: "Ember@1.11.0-beta.5",
      blockParams: 0,
      cachedFragment: null,
      hasRendered: false,
      build: function build(dom) {
        var el0 = dom.createDocumentFragment();
        var el1 = dom.createElement("div");
        dom.setAttribute(el1,"class","name-parent-div");
        var el2 = dom.createTextNode("\n");
        dom.appendChild(el1, el2);
        var el2 = dom.createComment("");
        dom.appendChild(el1, el2);
        var el2 = dom.createTextNode("\n");
        dom.appendChild(el1, el2);
        var el2 = dom.createComment("");
        dom.appendChild(el1, el2);
        var el2 = dom.createTextNode("\n");
        dom.appendChild(el1, el2);
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n\n");
        dom.appendChild(el0, el1);
        var el1 = dom.createElement("div");
        dom.setAttribute(el1,"class","zipcode-parent-div");
        var el2 = dom.createTextNode("\n");
        dom.appendChild(el1, el2);
        var el2 = dom.createComment("");
        dom.appendChild(el1, el2);
        var el2 = dom.createTextNode("\n");
        dom.appendChild(el1, el2);
        var el2 = dom.createComment("");
        dom.appendChild(el1, el2);
        var el2 = dom.createTextNode("\n");
        dom.appendChild(el1, el2);
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n\n");
        dom.appendChild(el0, el1);
        var el1 = dom.createElement("div");
        dom.setAttribute(el1,"class","email-parent-div");
        var el2 = dom.createTextNode("\n");
        dom.appendChild(el1, el2);
        var el2 = dom.createComment("");
        dom.appendChild(el1, el2);
        var el2 = dom.createTextNode("\n");
        dom.appendChild(el1, el2);
        var el2 = dom.createComment("");
        dom.appendChild(el1, el2);
        var el2 = dom.createTextNode("\n");
        dom.appendChild(el1, el2);
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n\n");
        dom.appendChild(el0, el1);
        var el1 = dom.createElement("div");
        dom.setAttribute(el1,"class","rando-parent-div");
        var el2 = dom.createTextNode("\n");
        dom.appendChild(el1, el2);
        var el2 = dom.createComment("");
        dom.appendChild(el1, el2);
        var el2 = dom.createTextNode("\n");
        dom.appendChild(el1, el2);
        var el2 = dom.createComment("");
        dom.appendChild(el1, el2);
        var el2 = dom.createTextNode("\n");
        dom.appendChild(el1, el2);
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n\n");
        dom.appendChild(el0, el1);
        var el1 = dom.createElement("div");
        dom.setAttribute(el1,"class","radeo-parent-div");
        var el2 = dom.createTextNode("\n  ");
        dom.appendChild(el1, el2);
        var el2 = dom.createElement("label");
        var el3 = dom.createTextNode("select an option");
        dom.appendChild(el2, el3);
        dom.appendChild(el1, el2);
        var el2 = dom.createTextNode("\n  ");
        dom.appendChild(el1, el2);
        var el2 = dom.createElement("div");
        dom.setAttribute(el2,"class","the-radio-buttons");
        var el3 = dom.createTextNode("\n    ");
        dom.appendChild(el2, el3);
        var el3 = dom.createElement("div");
        dom.setAttribute(el3,"class","radio-button-one");
        var el4 = dom.createTextNode("\n      ");
        dom.appendChild(el3, el4);
        var el4 = dom.createComment("");
        dom.appendChild(el3, el4);
        var el4 = dom.createTextNode("\n      ");
        dom.appendChild(el3, el4);
        var el4 = dom.createElement("label");
        dom.setAttribute(el4,"for","radio01");
        var el5 = dom.createTextNode("one");
        dom.appendChild(el4, el5);
        dom.appendChild(el3, el4);
        var el4 = dom.createTextNode("\n    ");
        dom.appendChild(el3, el4);
        dom.appendChild(el2, el3);
        var el3 = dom.createTextNode("\n    ");
        dom.appendChild(el2, el3);
        var el3 = dom.createElement("div");
        dom.setAttribute(el3,"class","radio-button-two");
        var el4 = dom.createTextNode("\n      ");
        dom.appendChild(el3, el4);
        var el4 = dom.createComment("");
        dom.appendChild(el3, el4);
        var el4 = dom.createTextNode("\n      ");
        dom.appendChild(el3, el4);
        var el4 = dom.createElement("label");
        dom.setAttribute(el4,"for","radio02");
        var el5 = dom.createTextNode("two");
        dom.appendChild(el4, el5);
        dom.appendChild(el3, el4);
        var el4 = dom.createTextNode("\n    ");
        dom.appendChild(el3, el4);
        dom.appendChild(el2, el3);
        var el3 = dom.createTextNode("\n  ");
        dom.appendChild(el2, el3);
        dom.appendChild(el1, el2);
        var el2 = dom.createTextNode("\n  ");
        dom.appendChild(el1, el2);
        var el2 = dom.createComment("");
        dom.appendChild(el1, el2);
        var el2 = dom.createTextNode("\n");
        dom.appendChild(el1, el2);
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n\n");
        dom.appendChild(el0, el1);
        var el1 = dom.createElement("div");
        dom.setAttribute(el1,"class","thing-parent-div");
        var el2 = dom.createTextNode("\n  ");
        dom.appendChild(el1, el2);
        var el2 = dom.createComment("");
        dom.appendChild(el1, el2);
        var el2 = dom.createTextNode("\n  ");
        dom.appendChild(el1, el2);
        var el2 = dom.createComment("");
        dom.appendChild(el1, el2);
        var el2 = dom.createTextNode("\n");
        dom.appendChild(el1, el2);
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n\n");
        dom.appendChild(el0, el1);
        var el1 = dom.createElement("div");
        dom.setAttribute(el1,"class","tos-parent-div");
        var el2 = dom.createTextNode("\n");
        dom.appendChild(el1, el2);
        var el2 = dom.createComment("");
        dom.appendChild(el1, el2);
        var el2 = dom.createTextNode("\n");
        dom.appendChild(el1, el2);
        var el2 = dom.createComment("");
        dom.appendChild(el1, el2);
        var el2 = dom.createTextNode("\n");
        dom.appendChild(el1, el2);
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n\n");
        dom.appendChild(el0, el1);
        var el1 = dom.createElement("button");
        dom.setAttribute(el1,"class","save");
        var el2 = dom.createTextNode("Save");
        dom.appendChild(el1, el2);
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n");
        dom.appendChild(el0, el1);
        return el0;
      },
      render: function render(context, env, contextualElement) {
        var dom = env.dom;
        var hooks = env.hooks, get = hooks.get, inline = hooks.inline, block = hooks.block, element = hooks.element;
        dom.detectNamespace(contextualElement);
        var fragment;
        if (env.useFragmentCache && dom.canClone) {
          if (this.cachedFragment === null) {
            fragment = this.build(dom);
            if (this.hasRendered) {
              this.cachedFragment = fragment;
            } else {
              this.hasRendered = true;
            }
          }
          if (this.cachedFragment) {
            fragment = dom.cloneNode(this.cachedFragment, true);
          }
        } else {
          fragment = this.build(dom);
        }
        var element0 = dom.childAt(fragment, [0]);
        var element1 = dom.childAt(fragment, [2]);
        var element2 = dom.childAt(fragment, [4]);
        var element3 = dom.childAt(fragment, [6]);
        var element4 = dom.childAt(fragment, [8]);
        var element5 = dom.childAt(element4, [3]);
        var element6 = dom.childAt(fragment, [10]);
        var element7 = dom.childAt(fragment, [12]);
        var element8 = dom.childAt(fragment, [14]);
        var morph0 = dom.createMorphAt(element0,1,1);
        var morph1 = dom.createMorphAt(element0,3,3);
        var morph2 = dom.createMorphAt(element1,1,1);
        var morph3 = dom.createMorphAt(element1,3,3);
        var morph4 = dom.createMorphAt(element2,1,1);
        var morph5 = dom.createMorphAt(element2,3,3);
        var morph6 = dom.createMorphAt(element3,1,1);
        var morph7 = dom.createMorphAt(element3,3,3);
        var morph8 = dom.createMorphAt(dom.childAt(element5, [1]),1,1);
        var morph9 = dom.createMorphAt(dom.childAt(element5, [3]),1,1);
        var morph10 = dom.createMorphAt(element4,5,5);
        var morph11 = dom.createMorphAt(element6,1,1);
        var morph12 = dom.createMorphAt(element6,3,3);
        var morph13 = dom.createMorphAt(element7,1,1);
        var morph14 = dom.createMorphAt(element7,3,3);
        inline(env, morph0, context, "input", [], {"value": get(env, context, "model.name"), "placeholder": "name"});
        block(env, morph1, context, "validation-error-field", [], {"submitted": get(env, context, "submitted"), "className": "red", "field": "name", "model": get(env, context, "model"), "validation": get(env, context, "nameValidation")}, child0, null);
        inline(env, morph2, context, "input", [], {"value": get(env, context, "model.zipcode"), "placeholder": "zipcode"});
        block(env, morph3, context, "validation-error-field", [], {"submitted": get(env, context, "submitted"), "field": "zipcode", "model": get(env, context, "model"), "validation": get(env, context, "zipcodeValidation")}, child1, null);
        inline(env, morph4, context, "input", [], {"value": get(env, context, "model.email"), "placeholder": "email"});
        block(env, morph5, context, "validation-error-field", [], {"delayed": true, "submitted": get(env, context, "submitted"), "className": "blue", "field": "email", "model": get(env, context, "model"), "validation": get(env, context, "emailValidation")}, child2, null);
        inline(env, morph6, context, "input", [], {"value": get(env, context, "model.rando"), "placeholder": "rando"});
        block(env, morph7, context, "validation-error-field", [], {"submitted": get(env, context, "submitted"), "field": "rando", "model": get(env, context, "model"), "validation": get(env, context, "randoValidation")}, child3, null);
        inline(env, morph8, context, "radio-button", [], {"groupValue": get(env, context, "model.radeo"), "id": "radio01", "value": 1});
        inline(env, morph9, context, "radio-button", [], {"groupValue": get(env, context, "model.radeo"), "id": "radio02", "value": 2});
        block(env, morph10, context, "validation-error-field", [], {"submitted": get(env, context, "submitted"), "field": "radeo", "model": get(env, context, "model"), "validation": get(env, context, "radeoValidation")}, child4, null);
        inline(env, morph11, context, "view", ["select"], {"prompt": "select a thing", "contentBinding": "controller.things", "valueBinding": "model.thing", "optionValuePath": "content.id", "optionLabelPath": "content.id"});
        block(env, morph12, context, "validation-error-field", [], {"submitted": get(env, context, "submitted"), "field": "thing", "model": get(env, context, "model"), "validation": get(env, context, "thingValidation")}, child5, null);
        inline(env, morph13, context, "input", [], {"checked": get(env, context, "model.tos"), "type": "checkbox"});
        block(env, morph14, context, "validation-error-field", [], {"submitted": get(env, context, "submitted"), "field": "tos", "model": get(env, context, "model"), "validation": get(env, context, "tosValidation")}, child6, null);
        element(env, element8, context, "action", ["save"], {});
        return fragment;
      }
    };
  }()));

});
define('dummy/templates/application', ['exports'], function (exports) {

  'use strict';

  exports['default'] = Ember.HTMLBars.template((function() {
    return {
      isHTMLBars: true,
      revision: "Ember@1.11.0-beta.5",
      blockParams: 0,
      cachedFragment: null,
      hasRendered: false,
      build: function build(dom) {
        var el0 = dom.createDocumentFragment();
        var el1 = dom.createElement("h2");
        dom.setAttribute(el1,"id","title");
        var el2 = dom.createTextNode("Welcome to Ember.js");
        dom.appendChild(el1, el2);
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n\n");
        dom.appendChild(el0, el1);
        var el1 = dom.createComment("");
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n");
        dom.appendChild(el0, el1);
        return el0;
      },
      render: function render(context, env, contextualElement) {
        var dom = env.dom;
        var hooks = env.hooks, content = hooks.content;
        dom.detectNamespace(contextualElement);
        var fragment;
        if (env.useFragmentCache && dom.canClone) {
          if (this.cachedFragment === null) {
            fragment = this.build(dom);
            if (this.hasRendered) {
              this.cachedFragment = fragment;
            } else {
              this.hasRendered = true;
            }
          }
          if (this.cachedFragment) {
            fragment = dom.cloneNode(this.cachedFragment, true);
          }
        } else {
          fragment = this.build(dom);
        }
        var morph0 = dom.createMorphAt(fragment,2,2,contextualElement);
        content(env, morph0, context, "outlet");
        return fragment;
      }
    };
  }()));

});
define('dummy/templates/edit', ['exports'], function (exports) {

  'use strict';

  exports['default'] = Ember.HTMLBars.template((function() {
    var child0 = (function() {
      return {
        isHTMLBars: true,
        revision: "Ember@1.11.0-beta.5",
        blockParams: 0,
        cachedFragment: null,
        hasRendered: false,
        build: function build(dom) {
          var el0 = dom.createDocumentFragment();
          var el1 = dom.createTextNode("invalid name");
          dom.appendChild(el0, el1);
          return el0;
        },
        render: function render(context, env, contextualElement) {
          var dom = env.dom;
          dom.detectNamespace(contextualElement);
          var fragment;
          if (env.useFragmentCache && dom.canClone) {
            if (this.cachedFragment === null) {
              fragment = this.build(dom);
              if (this.hasRendered) {
                this.cachedFragment = fragment;
              } else {
                this.hasRendered = true;
              }
            }
            if (this.cachedFragment) {
              fragment = dom.cloneNode(this.cachedFragment, true);
            }
          } else {
            fragment = this.build(dom);
          }
          return fragment;
        }
      };
    }());
    var child1 = (function() {
      return {
        isHTMLBars: true,
        revision: "Ember@1.11.0-beta.5",
        blockParams: 0,
        cachedFragment: null,
        hasRendered: false,
        build: function build(dom) {
          var el0 = dom.createDocumentFragment();
          var el1 = dom.createTextNode("invalid zipcode");
          dom.appendChild(el0, el1);
          return el0;
        },
        render: function render(context, env, contextualElement) {
          var dom = env.dom;
          dom.detectNamespace(contextualElement);
          var fragment;
          if (env.useFragmentCache && dom.canClone) {
            if (this.cachedFragment === null) {
              fragment = this.build(dom);
              if (this.hasRendered) {
                this.cachedFragment = fragment;
              } else {
                this.hasRendered = true;
              }
            }
            if (this.cachedFragment) {
              fragment = dom.cloneNode(this.cachedFragment, true);
            }
          } else {
            fragment = this.build(dom);
          }
          return fragment;
        }
      };
    }());
    var child2 = (function() {
      return {
        isHTMLBars: true,
        revision: "Ember@1.11.0-beta.5",
        blockParams: 0,
        cachedFragment: null,
        hasRendered: false,
        build: function build(dom) {
          var el0 = dom.createDocumentFragment();
          var el1 = dom.createTextNode("invalid email");
          dom.appendChild(el0, el1);
          return el0;
        },
        render: function render(context, env, contextualElement) {
          var dom = env.dom;
          dom.detectNamespace(contextualElement);
          var fragment;
          if (env.useFragmentCache && dom.canClone) {
            if (this.cachedFragment === null) {
              fragment = this.build(dom);
              if (this.hasRendered) {
                this.cachedFragment = fragment;
              } else {
                this.hasRendered = true;
              }
            }
            if (this.cachedFragment) {
              fragment = dom.cloneNode(this.cachedFragment, true);
            }
          } else {
            fragment = this.build(dom);
          }
          return fragment;
        }
      };
    }());
    return {
      isHTMLBars: true,
      revision: "Ember@1.11.0-beta.5",
      blockParams: 0,
      cachedFragment: null,
      hasRendered: false,
      build: function build(dom) {
        var el0 = dom.createDocumentFragment();
        var el1 = dom.createElement("div");
        dom.setAttribute(el1,"class","name-parent-div");
        var el2 = dom.createTextNode("\n");
        dom.appendChild(el1, el2);
        var el2 = dom.createComment("");
        dom.appendChild(el1, el2);
        var el2 = dom.createTextNode("\n");
        dom.appendChild(el1, el2);
        var el2 = dom.createComment("");
        dom.appendChild(el1, el2);
        var el2 = dom.createTextNode("\n");
        dom.appendChild(el1, el2);
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n\n");
        dom.appendChild(el0, el1);
        var el1 = dom.createElement("div");
        dom.setAttribute(el1,"class","zipcode-parent-div");
        var el2 = dom.createTextNode("\n");
        dom.appendChild(el1, el2);
        var el2 = dom.createComment("");
        dom.appendChild(el1, el2);
        var el2 = dom.createTextNode("\n");
        dom.appendChild(el1, el2);
        var el2 = dom.createComment("");
        dom.appendChild(el1, el2);
        var el2 = dom.createTextNode("\n");
        dom.appendChild(el1, el2);
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n\n");
        dom.appendChild(el0, el1);
        var el1 = dom.createElement("div");
        dom.setAttribute(el1,"class","email-parent-div");
        var el2 = dom.createTextNode("\n");
        dom.appendChild(el1, el2);
        var el2 = dom.createComment("");
        dom.appendChild(el1, el2);
        var el2 = dom.createTextNode("\n");
        dom.appendChild(el1, el2);
        var el2 = dom.createComment("");
        dom.appendChild(el1, el2);
        var el2 = dom.createTextNode("\n");
        dom.appendChild(el1, el2);
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n\n");
        dom.appendChild(el0, el1);
        var el1 = dom.createElement("button");
        var el2 = dom.createTextNode("Save");
        dom.appendChild(el1, el2);
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n");
        dom.appendChild(el0, el1);
        return el0;
      },
      render: function render(context, env, contextualElement) {
        var dom = env.dom;
        var hooks = env.hooks, get = hooks.get, inline = hooks.inline, block = hooks.block, element = hooks.element;
        dom.detectNamespace(contextualElement);
        var fragment;
        if (env.useFragmentCache && dom.canClone) {
          if (this.cachedFragment === null) {
            fragment = this.build(dom);
            if (this.hasRendered) {
              this.cachedFragment = fragment;
            } else {
              this.hasRendered = true;
            }
          }
          if (this.cachedFragment) {
            fragment = dom.cloneNode(this.cachedFragment, true);
          }
        } else {
          fragment = this.build(dom);
        }
        var element0 = dom.childAt(fragment, [0]);
        var element1 = dom.childAt(fragment, [2]);
        var element2 = dom.childAt(fragment, [4]);
        var element3 = dom.childAt(fragment, [6]);
        var morph0 = dom.createMorphAt(element0,1,1);
        var morph1 = dom.createMorphAt(element0,3,3);
        var morph2 = dom.createMorphAt(element1,1,1);
        var morph3 = dom.createMorphAt(element1,3,3);
        var morph4 = dom.createMorphAt(element2,1,1);
        var morph5 = dom.createMorphAt(element2,3,3);
        inline(env, morph0, context, "input", [], {"value": get(env, context, "model.name"), "placeholder": "name"});
        block(env, morph1, context, "validation-error-field", [], {"submitted": get(env, context, "submitted"), "className": "red", "field": "name", "model": get(env, context, "model"), "validation": get(env, context, "nameValidation")}, child0, null);
        inline(env, morph2, context, "input", [], {"value": get(env, context, "model.zipcode"), "placeholder": "zipcode"});
        block(env, morph3, context, "validation-error-field", [], {"submitted": get(env, context, "submitted"), "field": "zipcode", "model": get(env, context, "model"), "validation": get(env, context, "zipcodeValidation")}, child1, null);
        inline(env, morph4, context, "input", [], {"value": get(env, context, "model.email"), "placeholder": "email"});
        block(env, morph5, context, "validation-error-field", [], {"delayed": true, "submitted": get(env, context, "submitted"), "className": "blue", "field": "email", "model": get(env, context, "model"), "validation": get(env, context, "emailValidation")}, child2, null);
        element(env, element3, context, "action", ["save"], {});
        return fragment;
      }
    };
  }()));

});
define('dummy/templates/many', ['exports'], function (exports) {

  'use strict';

  exports['default'] = Ember.HTMLBars.template((function() {
    var child0 = (function() {
      var child0 = (function() {
        return {
          isHTMLBars: true,
          revision: "Ember@1.11.0-beta.5",
          blockParams: 0,
          cachedFragment: null,
          hasRendered: false,
          build: function build(dom) {
            var el0 = dom.createDocumentFragment();
            var el1 = dom.createTextNode("invalid basic");
            dom.appendChild(el0, el1);
            return el0;
          },
          render: function render(context, env, contextualElement) {
            var dom = env.dom;
            dom.detectNamespace(contextualElement);
            var fragment;
            if (env.useFragmentCache && dom.canClone) {
              if (this.cachedFragment === null) {
                fragment = this.build(dom);
                if (this.hasRendered) {
                  this.cachedFragment = fragment;
                } else {
                  this.hasRendered = true;
                }
              }
              if (this.cachedFragment) {
                fragment = dom.cloneNode(this.cachedFragment, true);
              }
            } else {
              fragment = this.build(dom);
            }
            return fragment;
          }
        };
      }());
      var child1 = (function() {
        return {
          isHTMLBars: true,
          revision: "Ember@1.11.0-beta.5",
          blockParams: 0,
          cachedFragment: null,
          hasRendered: false,
          build: function build(dom) {
            var el0 = dom.createDocumentFragment();
            var el1 = dom.createTextNode("invalid len");
            dom.appendChild(el0, el1);
            return el0;
          },
          render: function render(context, env, contextualElement) {
            var dom = env.dom;
            dom.detectNamespace(contextualElement);
            var fragment;
            if (env.useFragmentCache && dom.canClone) {
              if (this.cachedFragment === null) {
                fragment = this.build(dom);
                if (this.hasRendered) {
                  this.cachedFragment = fragment;
                } else {
                  this.hasRendered = true;
                }
              }
              if (this.cachedFragment) {
                fragment = dom.cloneNode(this.cachedFragment, true);
              }
            } else {
              fragment = this.build(dom);
            }
            return fragment;
          }
        };
      }());
      return {
        isHTMLBars: true,
        revision: "Ember@1.11.0-beta.5",
        blockParams: 2,
        cachedFragment: null,
        hasRendered: false,
        build: function build(dom) {
          var el0 = dom.createDocumentFragment();
          var el1 = dom.createTextNode("  ");
          dom.appendChild(el0, el1);
          var el1 = dom.createElement("div");
          dom.setAttribute(el1,"class","name-parent-div");
          var el2 = dom.createTextNode("\n    ");
          dom.appendChild(el1, el2);
          var el2 = dom.createComment("");
          dom.appendChild(el1, el2);
          var el2 = dom.createTextNode("\n    ");
          dom.appendChild(el1, el2);
          var el2 = dom.createComment("");
          dom.appendChild(el1, el2);
          var el2 = dom.createTextNode("\n    ");
          dom.appendChild(el1, el2);
          var el2 = dom.createComment("");
          dom.appendChild(el1, el2);
          var el2 = dom.createTextNode("\n  ");
          dom.appendChild(el1, el2);
          dom.appendChild(el0, el1);
          var el1 = dom.createTextNode("\n");
          dom.appendChild(el0, el1);
          return el0;
        },
        render: function render(context, env, contextualElement, blockArguments) {
          var dom = env.dom;
          var hooks = env.hooks, set = hooks.set, get = hooks.get, inline = hooks.inline, block = hooks.block;
          dom.detectNamespace(contextualElement);
          var fragment;
          if (env.useFragmentCache && dom.canClone) {
            if (this.cachedFragment === null) {
              fragment = this.build(dom);
              if (this.hasRendered) {
                this.cachedFragment = fragment;
              } else {
                this.hasRendered = true;
              }
            }
            if (this.cachedFragment) {
              fragment = dom.cloneNode(this.cachedFragment, true);
            }
          } else {
            fragment = this.build(dom);
          }
          var element0 = dom.childAt(fragment, [1]);
          var morph0 = dom.createMorphAt(element0,1,1);
          var morph1 = dom.createMorphAt(element0,3,3);
          var morph2 = dom.createMorphAt(element0,5,5);
          set(env, context, "person", blockArguments[0]);
          set(env, context, "index", blockArguments[1]);
          inline(env, morph0, context, "input", [], {"value": get(env, context, "person.name"), "placeholder": "name"});
          block(env, morph1, context, "validation-error-field", [], {"submitted": get(env, context, "submitted"), "className": "basic", "field": "name", "model": get(env, context, "person"), "index": get(env, context, "index"), "validation": "basic"}, child0, null);
          block(env, morph2, context, "validation-error-field", [], {"submitted": get(env, context, "submitted"), "className": "len", "field": "name", "model": get(env, context, "person"), "index": get(env, context, "index"), "validation": "len"}, child1, null);
          return fragment;
        }
      };
    }());
    return {
      isHTMLBars: true,
      revision: "Ember@1.11.0-beta.5",
      blockParams: 0,
      cachedFragment: null,
      hasRendered: false,
      build: function build(dom) {
        var el0 = dom.createDocumentFragment();
        var el1 = dom.createComment("");
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n");
        dom.appendChild(el0, el1);
        var el1 = dom.createElement("button");
        dom.setAttribute(el1,"class","save");
        var el2 = dom.createTextNode("Save");
        dom.appendChild(el1, el2);
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n");
        dom.appendChild(el0, el1);
        return el0;
      },
      render: function render(context, env, contextualElement) {
        var dom = env.dom;
        var hooks = env.hooks, get = hooks.get, block = hooks.block, element = hooks.element;
        dom.detectNamespace(contextualElement);
        var fragment;
        if (env.useFragmentCache && dom.canClone) {
          if (this.cachedFragment === null) {
            fragment = this.build(dom);
            if (this.hasRendered) {
              this.cachedFragment = fragment;
            } else {
              this.hasRendered = true;
            }
          }
          if (this.cachedFragment) {
            fragment = dom.cloneNode(this.cachedFragment, true);
          }
        } else {
          fragment = this.build(dom);
        }
        var element1 = dom.childAt(fragment, [2]);
        var morph0 = dom.createMorphAt(fragment,0,0,contextualElement);
        dom.insertBoundary(fragment, 0);
        block(env, morph0, context, "each", [get(env, context, "model")], {}, child0, null);
        element(env, element1, context, "action", ["save"], {});
        return fragment;
      }
    };
  }()));

});
define('dummy/templates/multi', ['exports'], function (exports) {

  'use strict';

  exports['default'] = Ember.HTMLBars.template((function() {
    var child0 = (function() {
      var child0 = (function() {
        return {
          isHTMLBars: true,
          revision: "Ember@1.11.0-beta.5",
          blockParams: 0,
          cachedFragment: null,
          hasRendered: false,
          build: function build(dom) {
            var el0 = dom.createDocumentFragment();
            var el1 = dom.createTextNode("invalid name");
            dom.appendChild(el0, el1);
            return el0;
          },
          render: function render(context, env, contextualElement) {
            var dom = env.dom;
            dom.detectNamespace(contextualElement);
            var fragment;
            if (env.useFragmentCache && dom.canClone) {
              if (this.cachedFragment === null) {
                fragment = this.build(dom);
                if (this.hasRendered) {
                  this.cachedFragment = fragment;
                } else {
                  this.hasRendered = true;
                }
              }
              if (this.cachedFragment) {
                fragment = dom.cloneNode(this.cachedFragment, true);
              }
            } else {
              fragment = this.build(dom);
            }
            return fragment;
          }
        };
      }());
      var child1 = (function() {
        return {
          isHTMLBars: true,
          revision: "Ember@1.11.0-beta.5",
          blockParams: 0,
          cachedFragment: null,
          hasRendered: false,
          build: function build(dom) {
            var el0 = dom.createDocumentFragment();
            var el1 = dom.createTextNode("invalid rando");
            dom.appendChild(el0, el1);
            return el0;
          },
          render: function render(context, env, contextualElement) {
            var dom = env.dom;
            dom.detectNamespace(contextualElement);
            var fragment;
            if (env.useFragmentCache && dom.canClone) {
              if (this.cachedFragment === null) {
                fragment = this.build(dom);
                if (this.hasRendered) {
                  this.cachedFragment = fragment;
                } else {
                  this.hasRendered = true;
                }
              }
              if (this.cachedFragment) {
                fragment = dom.cloneNode(this.cachedFragment, true);
              }
            } else {
              fragment = this.build(dom);
            }
            return fragment;
          }
        };
      }());
      return {
        isHTMLBars: true,
        revision: "Ember@1.11.0-beta.5",
        blockParams: 2,
        cachedFragment: null,
        hasRendered: false,
        build: function build(dom) {
          var el0 = dom.createDocumentFragment();
          var el1 = dom.createTextNode("  ");
          dom.appendChild(el0, el1);
          var el1 = dom.createElement("div");
          dom.setAttribute(el1,"class","name-parent-div");
          var el2 = dom.createTextNode("\n    ");
          dom.appendChild(el1, el2);
          var el2 = dom.createComment("");
          dom.appendChild(el1, el2);
          var el2 = dom.createTextNode("\n    ");
          dom.appendChild(el1, el2);
          var el2 = dom.createComment("");
          dom.appendChild(el1, el2);
          var el2 = dom.createTextNode("\n  ");
          dom.appendChild(el1, el2);
          dom.appendChild(el0, el1);
          var el1 = dom.createTextNode("\n\n  ");
          dom.appendChild(el0, el1);
          var el1 = dom.createElement("div");
          dom.setAttribute(el1,"class","rando-parent-div");
          var el2 = dom.createTextNode("\n    ");
          dom.appendChild(el1, el2);
          var el2 = dom.createComment("");
          dom.appendChild(el1, el2);
          var el2 = dom.createTextNode("\n    ");
          dom.appendChild(el1, el2);
          var el2 = dom.createComment("");
          dom.appendChild(el1, el2);
          var el2 = dom.createTextNode("\n  ");
          dom.appendChild(el1, el2);
          dom.appendChild(el0, el1);
          var el1 = dom.createTextNode("\n\n  ");
          dom.appendChild(el0, el1);
          var el1 = dom.createElement("button");
          dom.setAttribute(el1,"class","remove");
          var el2 = dom.createTextNode("Remove");
          dom.appendChild(el1, el2);
          dom.appendChild(el0, el1);
          var el1 = dom.createTextNode("\n");
          dom.appendChild(el0, el1);
          return el0;
        },
        render: function render(context, env, contextualElement, blockArguments) {
          var dom = env.dom;
          var hooks = env.hooks, set = hooks.set, get = hooks.get, inline = hooks.inline, block = hooks.block, element = hooks.element;
          dom.detectNamespace(contextualElement);
          var fragment;
          if (env.useFragmentCache && dom.canClone) {
            if (this.cachedFragment === null) {
              fragment = this.build(dom);
              if (this.hasRendered) {
                this.cachedFragment = fragment;
              } else {
                this.hasRendered = true;
              }
            }
            if (this.cachedFragment) {
              fragment = dom.cloneNode(this.cachedFragment, true);
            }
          } else {
            fragment = this.build(dom);
          }
          var element0 = dom.childAt(fragment, [1]);
          var element1 = dom.childAt(fragment, [3]);
          var element2 = dom.childAt(fragment, [5]);
          var morph0 = dom.createMorphAt(element0,1,1);
          var morph1 = dom.createMorphAt(element0,3,3);
          var morph2 = dom.createMorphAt(element1,1,1);
          var morph3 = dom.createMorphAt(element1,3,3);
          set(env, context, "person", blockArguments[0]);
          set(env, context, "index", blockArguments[1]);
          inline(env, morph0, context, "input", [], {"value": get(env, context, "person.name"), "placeholder": "name"});
          block(env, morph1, context, "validation-error-field", [], {"submitted": get(env, context, "submitted"), "className": "red", "field": "name", "model": get(env, context, "person"), "index": get(env, context, "index"), "validation": "name"}, child0, null);
          inline(env, morph2, context, "input", [], {"value": get(env, context, "person.rando"), "placeholder": "rando"});
          block(env, morph3, context, "validation-error-field", [], {"submitted": get(env, context, "submitted"), "className": "red", "field": "rando", "model": get(env, context, "person"), "index": get(env, context, "index"), "validation": "rando"}, child1, null);
          element(env, element2, context, "action", ["remove", get(env, context, "person")], {});
          return fragment;
        }
      };
    }());
    return {
      isHTMLBars: true,
      revision: "Ember@1.11.0-beta.5",
      blockParams: 0,
      cachedFragment: null,
      hasRendered: false,
      build: function build(dom) {
        var el0 = dom.createDocumentFragment();
        var el1 = dom.createComment("");
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n");
        dom.appendChild(el0, el1);
        var el1 = dom.createElement("button");
        dom.setAttribute(el1,"class","save");
        var el2 = dom.createTextNode("Save");
        dom.appendChild(el1, el2);
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n\n");
        dom.appendChild(el0, el1);
        var el1 = dom.createElement("br");
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n");
        dom.appendChild(el0, el1);
        var el1 = dom.createElement("button");
        dom.setAttribute(el1,"class","add");
        var el2 = dom.createTextNode("Add Another");
        dom.appendChild(el1, el2);
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n");
        dom.appendChild(el0, el1);
        return el0;
      },
      render: function render(context, env, contextualElement) {
        var dom = env.dom;
        var hooks = env.hooks, get = hooks.get, block = hooks.block, element = hooks.element;
        dom.detectNamespace(contextualElement);
        var fragment;
        if (env.useFragmentCache && dom.canClone) {
          if (this.cachedFragment === null) {
            fragment = this.build(dom);
            if (this.hasRendered) {
              this.cachedFragment = fragment;
            } else {
              this.hasRendered = true;
            }
          }
          if (this.cachedFragment) {
            fragment = dom.cloneNode(this.cachedFragment, true);
          }
        } else {
          fragment = this.build(dom);
        }
        var element3 = dom.childAt(fragment, [2]);
        var element4 = dom.childAt(fragment, [6]);
        var morph0 = dom.createMorphAt(fragment,0,0,contextualElement);
        dom.insertBoundary(fragment, 0);
        block(env, morph0, context, "each", [get(env, context, "model")], {}, child0, null);
        element(env, element3, context, "action", ["save"], {});
        element(env, element4, context, "action", ["add"], {});
        return fragment;
      }
    };
  }()));

});
define('dummy/templates/other', ['exports'], function (exports) {

  'use strict';

  exports['default'] = Ember.HTMLBars.template((function() {
    var child0 = (function() {
      var child0 = (function() {
        return {
          isHTMLBars: true,
          revision: "Ember@1.11.0-beta.5",
          blockParams: 0,
          cachedFragment: null,
          hasRendered: false,
          build: function build(dom) {
            var el0 = dom.createDocumentFragment();
            var el1 = dom.createTextNode("invalid displayName");
            dom.appendChild(el0, el1);
            return el0;
          },
          render: function render(context, env, contextualElement) {
            var dom = env.dom;
            dom.detectNamespace(contextualElement);
            var fragment;
            if (env.useFragmentCache && dom.canClone) {
              if (this.cachedFragment === null) {
                fragment = this.build(dom);
                if (this.hasRendered) {
                  this.cachedFragment = fragment;
                } else {
                  this.hasRendered = true;
                }
              }
              if (this.cachedFragment) {
                fragment = dom.cloneNode(this.cachedFragment, true);
              }
            } else {
              fragment = this.build(dom);
            }
            return fragment;
          }
        };
      }());
      var child1 = (function() {
        return {
          isHTMLBars: true,
          revision: "Ember@1.11.0-beta.5",
          blockParams: 0,
          cachedFragment: null,
          hasRendered: false,
          build: function build(dom) {
            var el0 = dom.createDocumentFragment();
            var el1 = dom.createTextNode("invalid tos");
            dom.appendChild(el0, el1);
            return el0;
          },
          render: function render(context, env, contextualElement) {
            var dom = env.dom;
            dom.detectNamespace(contextualElement);
            var fragment;
            if (env.useFragmentCache && dom.canClone) {
              if (this.cachedFragment === null) {
                fragment = this.build(dom);
                if (this.hasRendered) {
                  this.cachedFragment = fragment;
                } else {
                  this.hasRendered = true;
                }
              }
              if (this.cachedFragment) {
                fragment = dom.cloneNode(this.cachedFragment, true);
              }
            } else {
              fragment = this.build(dom);
            }
            return fragment;
          }
        };
      }());
      return {
        isHTMLBars: true,
        revision: "Ember@1.11.0-beta.5",
        blockParams: 2,
        cachedFragment: null,
        hasRendered: false,
        build: function build(dom) {
          var el0 = dom.createDocumentFragment();
          var el1 = dom.createTextNode("  ");
          dom.appendChild(el0, el1);
          var el1 = dom.createElement("div");
          dom.setAttribute(el1,"class","display-name-parent-div");
          var el2 = dom.createTextNode("\n    ");
          dom.appendChild(el1, el2);
          var el2 = dom.createComment("");
          dom.appendChild(el1, el2);
          var el2 = dom.createTextNode("\n    ");
          dom.appendChild(el1, el2);
          var el2 = dom.createComment("");
          dom.appendChild(el1, el2);
          var el2 = dom.createTextNode("\n  ");
          dom.appendChild(el1, el2);
          dom.appendChild(el0, el1);
          var el1 = dom.createTextNode("\n\n  ");
          dom.appendChild(el0, el1);
          var el1 = dom.createElement("div");
          dom.setAttribute(el1,"class","tos-parent-div");
          var el2 = dom.createTextNode("\n    ");
          dom.appendChild(el1, el2);
          var el2 = dom.createComment("");
          dom.appendChild(el1, el2);
          var el2 = dom.createTextNode("\n    ");
          dom.appendChild(el1, el2);
          var el2 = dom.createComment("");
          dom.appendChild(el1, el2);
          var el2 = dom.createTextNode("\n  ");
          dom.appendChild(el1, el2);
          dom.appendChild(el0, el1);
          var el1 = dom.createTextNode("\n\n  ");
          dom.appendChild(el0, el1);
          var el1 = dom.createElement("button");
          dom.setAttribute(el1,"class","remove");
          var el2 = dom.createTextNode("Remove");
          dom.appendChild(el1, el2);
          dom.appendChild(el0, el1);
          var el1 = dom.createTextNode("\n");
          dom.appendChild(el0, el1);
          return el0;
        },
        render: function render(context, env, contextualElement, blockArguments) {
          var dom = env.dom;
          var hooks = env.hooks, set = hooks.set, get = hooks.get, inline = hooks.inline, block = hooks.block, element = hooks.element;
          dom.detectNamespace(contextualElement);
          var fragment;
          if (env.useFragmentCache && dom.canClone) {
            if (this.cachedFragment === null) {
              fragment = this.build(dom);
              if (this.hasRendered) {
                this.cachedFragment = fragment;
              } else {
                this.hasRendered = true;
              }
            }
            if (this.cachedFragment) {
              fragment = dom.cloneNode(this.cachedFragment, true);
            }
          } else {
            fragment = this.build(dom);
          }
          var element0 = dom.childAt(fragment, [1]);
          var element1 = dom.childAt(fragment, [3]);
          var element2 = dom.childAt(fragment, [5]);
          var morph0 = dom.createMorphAt(element0,1,1);
          var morph1 = dom.createMorphAt(element0,3,3);
          var morph2 = dom.createMorphAt(element1,1,1);
          var morph3 = dom.createMorphAt(element1,3,3);
          set(env, context, "other", blockArguments[0]);
          set(env, context, "index", blockArguments[1]);
          inline(env, morph0, context, "input", [], {"value": get(env, context, "other.displayName"), "placeholder": "displayName"});
          block(env, morph1, context, "validation-error-field", [], {"submitted": get(env, context, "submitted"), "field": "displayName", "model": get(env, context, "other"), "index": get(env, context, "index"), "validation": "displayName"}, child0, null);
          inline(env, morph2, context, "input", [], {"checked": get(env, context, "other.tos"), "type": "checkbox"});
          block(env, morph3, context, "validation-error-field", [], {"submitted": get(env, context, "submitted"), "field": "tos", "model": get(env, context, "other"), "index": get(env, context, "index"), "validation": "tos"}, child1, null);
          element(env, element2, context, "action", ["remove", get(env, context, "other")], {});
          return fragment;
        }
      };
    }());
    return {
      isHTMLBars: true,
      revision: "Ember@1.11.0-beta.5",
      blockParams: 0,
      cachedFragment: null,
      hasRendered: false,
      build: function build(dom) {
        var el0 = dom.createDocumentFragment();
        var el1 = dom.createComment("");
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n");
        dom.appendChild(el0, el1);
        var el1 = dom.createElement("button");
        dom.setAttribute(el1,"class","save");
        var el2 = dom.createTextNode("Save");
        dom.appendChild(el1, el2);
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n\n");
        dom.appendChild(el0, el1);
        var el1 = dom.createElement("br");
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n");
        dom.appendChild(el0, el1);
        var el1 = dom.createElement("button");
        dom.setAttribute(el1,"class","add");
        var el2 = dom.createTextNode("Add Another");
        dom.appendChild(el1, el2);
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n");
        dom.appendChild(el0, el1);
        return el0;
      },
      render: function render(context, env, contextualElement) {
        var dom = env.dom;
        var hooks = env.hooks, get = hooks.get, block = hooks.block, element = hooks.element;
        dom.detectNamespace(contextualElement);
        var fragment;
        if (env.useFragmentCache && dom.canClone) {
          if (this.cachedFragment === null) {
            fragment = this.build(dom);
            if (this.hasRendered) {
              this.cachedFragment = fragment;
            } else {
              this.hasRendered = true;
            }
          }
          if (this.cachedFragment) {
            fragment = dom.cloneNode(this.cachedFragment, true);
          }
        } else {
          fragment = this.build(dom);
        }
        var element3 = dom.childAt(fragment, [2]);
        var element4 = dom.childAt(fragment, [6]);
        var morph0 = dom.createMorphAt(fragment,0,0,contextualElement);
        dom.insertBoundary(fragment, 0);
        block(env, morph0, context, "each", [get(env, context, "model")], {}, child0, null);
        element(env, element3, context, "action", ["save"], {});
        element(env, element4, context, "action", ["add"], {});
        return fragment;
      }
    };
  }()));

});
define('dummy/templates/success', ['exports'], function (exports) {

  'use strict';

  exports['default'] = Ember.HTMLBars.template((function() {
    return {
      isHTMLBars: true,
      revision: "Ember@1.11.0-beta.5",
      blockParams: 0,
      cachedFragment: null,
      hasRendered: false,
      build: function build(dom) {
        var el0 = dom.createDocumentFragment();
        var el1 = dom.createElement("div");
        dom.setAttribute(el1,"class","success");
        var el2 = dom.createTextNode("valid form was submitted");
        dom.appendChild(el1, el2);
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n");
        dom.appendChild(el0, el1);
        return el0;
      },
      render: function render(context, env, contextualElement) {
        var dom = env.dom;
        dom.detectNamespace(contextualElement);
        var fragment;
        if (env.useFragmentCache && dom.canClone) {
          if (this.cachedFragment === null) {
            fragment = this.build(dom);
            if (this.hasRendered) {
              this.cachedFragment = fragment;
            } else {
              this.hasRendered = true;
            }
          }
          if (this.cachedFragment) {
            fragment = dom.cloneNode(this.cachedFragment, true);
          }
        } else {
          fragment = this.build(dom);
        }
        return fragment;
      }
    };
  }()));

});
define('dummy/tests/acceptance/array-form-validation-test', ['ember', 'dummy/tests/helpers/start-app', 'qunit'], function (Ember, startApp, qunit) {

  'use strict';

  var application;

  var SAVE_BUTTON = "button.save";
  var ADD_BUTTON = "button.add";
  var VALID_NAME = "x";
  var VALID_RANDO = "2";
  var INVALID_NAME = "";
  var INVALID_RANDO = "1";

  var FIRST_NAME_ERROR_FIELD = ".name-parent-div:eq(0) span";
  var FIRST_RANDO_ERROR_FIELD = ".rando-parent-div:eq(0) span";
  var FIRST_NAME_INPUT = ".name-parent-div:eq(0) input";
  var FIRST_RANDO_INPUT = ".rando-parent-div:eq(0) input";

  var SECOND_NAME_ERROR_FIELD = ".name-parent-div:eq(1) span";
  var SECOND_RANDO_ERROR_FIELD = ".rando-parent-div:eq(1) span";
  var SECOND_NAME_INPUT = ".name-parent-div:eq(1) input";
  var SECOND_RANDO_INPUT = ".rando-parent-div:eq(1) input";

  var THIRD_NAME_ERROR_FIELD = ".name-parent-div:eq(2) span";
  var THIRD_RANDO_ERROR_FIELD = ".rando-parent-div:eq(2) span";
  var THIRD_NAME_INPUT = ".name-parent-div:eq(2) input";
  var THIRD_RANDO_INPUT = ".rando-parent-div:eq(2) input";

  var FOURTH_NAME_ERROR_FIELD = ".name-parent-div:eq(3) span";
  var FOURTH_RANDO_ERROR_FIELD = ".rando-parent-div:eq(3) span";
  var FOURTH_NAME_INPUT = ".name-parent-div:eq(3) input";
  var FOURTH_RANDO_INPUT = ".rando-parent-div:eq(3) input";

  qunit.module("Acceptance: Array Form Validation", {
    setup: function setup() {
      application = startApp['default']();
    },
    teardown: function teardown() {
      Ember['default'].run(application, "destroy");
    }
  });

  qunit.test("clicking save will transition to success when each field is valid", function (assert) {
    visit("/multi");
    fillIn(FIRST_NAME_INPUT, VALID_NAME);
    fillIn(SECOND_NAME_INPUT, VALID_NAME);
    fillIn(THIRD_NAME_INPUT, VALID_NAME);
    fillIn(FIRST_RANDO_INPUT, VALID_RANDO);
    fillIn(SECOND_RANDO_INPUT, VALID_RANDO);
    fillIn(THIRD_RANDO_INPUT, VALID_RANDO);
    click(SAVE_BUTTON);
    andThen(function () {
      assert.equal(currentURL(), "/success");
    });
  });

  qunit.test("clicking save will not transition to success when only the last field is valid", function (assert) {
    visit("/multi");
    click(SAVE_BUTTON);
    andThen(function () {
      assert.equal(currentURL(), "/multi");
    });
    fillIn(THIRD_RANDO_INPUT, VALID_RANDO);
    andThen(function () {
      assert.equal(currentURL(), "/multi");
    });
    fillIn(THIRD_NAME_INPUT, VALID_NAME);
    andThen(function () {
      assert.equal(currentURL(), "/multi");
    });
    fillIn(FIRST_NAME_INPUT, VALID_NAME);
    fillIn(SECOND_NAME_INPUT, VALID_NAME);
    fillIn(FIRST_RANDO_INPUT, VALID_RANDO);
    fillIn(SECOND_RANDO_INPUT, VALID_RANDO);
    click(SAVE_BUTTON);
    andThen(function () {
      assert.equal(currentURL(), "/success");
    });
  });

  qunit.test("string based inputs with default validation will not accept empty string as valid", function (assert) {
    visit("/multi");
    andThen(function () {
      assert.equal(find(FIRST_NAME_ERROR_FIELD).hasClass("hidden"), true);
      assert.equal(find(SECOND_NAME_ERROR_FIELD).hasClass("hidden"), true);
      assert.equal(find(THIRD_NAME_ERROR_FIELD).hasClass("hidden"), true);
    });
    fillIn(FIRST_NAME_INPUT, " ");
    andThen(function () {
      assert.equal(find(FIRST_NAME_ERROR_FIELD).hasClass("hidden"), false);
      assert.equal(find(SECOND_NAME_ERROR_FIELD).hasClass("hidden"), true);
      assert.equal(find(THIRD_NAME_ERROR_FIELD).hasClass("hidden"), true);
    });
    fillIn(FIRST_NAME_INPUT, VALID_NAME);
    fillIn(SECOND_NAME_INPUT, " ");
    andThen(function () {
      assert.equal(find(FIRST_NAME_ERROR_FIELD).hasClass("hidden"), true);
      assert.equal(find(SECOND_NAME_ERROR_FIELD).hasClass("hidden"), false);
      assert.equal(find(THIRD_NAME_ERROR_FIELD).hasClass("hidden"), true);
    });
    fillIn(FIRST_NAME_INPUT, VALID_NAME);
    fillIn(SECOND_NAME_INPUT, VALID_NAME);
    fillIn(THIRD_NAME_INPUT, " ");
    andThen(function () {
      assert.equal(find(FIRST_NAME_ERROR_FIELD).hasClass("hidden"), true);
      assert.equal(find(SECOND_NAME_ERROR_FIELD).hasClass("hidden"), true);
      assert.equal(find(THIRD_NAME_ERROR_FIELD).hasClass("hidden"), false);
    });
    fillIn(THIRD_NAME_INPUT, VALID_NAME);
    click(SAVE_BUTTON);
    andThen(function () {
      assert.equal(find(FIRST_NAME_ERROR_FIELD).hasClass("hidden"), true);
      assert.equal(find(SECOND_NAME_ERROR_FIELD).hasClass("hidden"), true);
      assert.equal(find(THIRD_NAME_ERROR_FIELD).hasClass("hidden"), true);
      assert.equal(find(FIRST_RANDO_ERROR_FIELD).hasClass("hidden"), false);
      assert.equal(find(SECOND_RANDO_ERROR_FIELD).hasClass("hidden"), false);
      assert.equal(find(THIRD_RANDO_ERROR_FIELD).hasClass("hidden"), false);
    });
    fillIn(FIRST_RANDO_INPUT, VALID_RANDO);
    fillIn(SECOND_RANDO_INPUT, VALID_RANDO);
    fillIn(THIRD_RANDO_INPUT, VALID_RANDO);
    click(SAVE_BUTTON);
    andThen(function () {
      assert.equal(currentURL(), "/success");
    });
  });

  qunit.test("clicking save will fire each validation", function (assert) {
    visit("/multi");
    andThen(function () {
      assert.equal(currentURL(), "/multi");
      assert.equal(find(FIRST_NAME_ERROR_FIELD).hasClass("hidden"), true);
      assert.equal(find(SECOND_NAME_ERROR_FIELD).hasClass("hidden"), true);
      assert.equal(find(THIRD_NAME_ERROR_FIELD).hasClass("hidden"), true);
      assert.equal(find(FIRST_RANDO_ERROR_FIELD).hasClass("hidden"), true);
      assert.equal(find(SECOND_RANDO_ERROR_FIELD).hasClass("hidden"), true);
      assert.equal(find(THIRD_RANDO_ERROR_FIELD).hasClass("hidden"), true);
    });
    click(SAVE_BUTTON);
    andThen(function () {
      assert.equal(currentURL(), "/multi");
      assert.equal(find(FIRST_NAME_ERROR_FIELD).hasClass("hidden"), false);
      assert.equal(find(SECOND_NAME_ERROR_FIELD).hasClass("hidden"), false);
      assert.equal(find(THIRD_NAME_ERROR_FIELD).hasClass("hidden"), false);
      assert.equal(find(FIRST_RANDO_ERROR_FIELD).hasClass("hidden"), false);
      assert.equal(find(SECOND_RANDO_ERROR_FIELD).hasClass("hidden"), false);
      assert.equal(find(THIRD_RANDO_ERROR_FIELD).hasClass("hidden"), false);
    });
  });

  qunit.test("component will render with the correct text and css class", function (assert) {
    visit("/multi");
    click(SAVE_BUTTON);
    andThen(function () {
      assert.equal(currentURL(), "/multi");
      assert.equal(find(FIRST_NAME_ERROR_FIELD).hasClass("red"), true);
      assert.equal(find(FIRST_NAME_ERROR_FIELD).text(), "invalid name");
      assert.equal(find(FIRST_RANDO_ERROR_FIELD).text(), "invalid rando");

      assert.equal(find(SECOND_NAME_ERROR_FIELD).hasClass("red"), true);
      assert.equal(find(SECOND_NAME_ERROR_FIELD).text(), "invalid name");
      assert.equal(find(SECOND_RANDO_ERROR_FIELD).text(), "invalid rando");

      assert.equal(find(THIRD_NAME_ERROR_FIELD).hasClass("red"), true);
      assert.equal(find(THIRD_NAME_ERROR_FIELD).text(), "invalid name");
      assert.equal(find(THIRD_RANDO_ERROR_FIELD).text(), "invalid rando");
    });
  });

  qunit.test("adding and removing elements from the array will keep validations in sync", function (assert) {
    visit("/multi");
    andThen(function () {
      assert.equal(find(FIRST_NAME_ERROR_FIELD).hasClass("hidden"), true);
      assert.equal(find(SECOND_NAME_ERROR_FIELD).hasClass("hidden"), true);
      assert.equal(find(THIRD_NAME_ERROR_FIELD).hasClass("hidden"), true);
      assert.equal(find(FIRST_RANDO_ERROR_FIELD).hasClass("hidden"), true);
      assert.equal(find(SECOND_RANDO_ERROR_FIELD).hasClass("hidden"), true);
      assert.equal(find(THIRD_RANDO_ERROR_FIELD).hasClass("hidden"), true);
    });
    click(SAVE_BUTTON);
    andThen(function () {
      assert.equal(find(FIRST_NAME_ERROR_FIELD).hasClass("hidden"), false);
      assert.equal(find(SECOND_NAME_ERROR_FIELD).hasClass("hidden"), false);
      assert.equal(find(THIRD_NAME_ERROR_FIELD).hasClass("hidden"), false);
      assert.equal(find(FIRST_RANDO_ERROR_FIELD).hasClass("hidden"), false);
      assert.equal(find(SECOND_RANDO_ERROR_FIELD).hasClass("hidden"), false);
      assert.equal(find(THIRD_RANDO_ERROR_FIELD).hasClass("hidden"), false);
    });
    fillIn(THIRD_NAME_INPUT, VALID_NAME);
    fillIn(FIRST_RANDO_INPUT, VALID_RANDO);
    andThen(function () {
      assert.equal(find(".name-parent-div span").length, 3);
      assert.equal(currentURL(), "/multi");
      assert.equal(find(FIRST_NAME_ERROR_FIELD).hasClass("hidden"), false);
      assert.equal(find(SECOND_NAME_ERROR_FIELD).hasClass("hidden"), false);
      assert.equal(find(THIRD_NAME_ERROR_FIELD).hasClass("hidden"), true);
      assert.equal(find(FIRST_RANDO_ERROR_FIELD).hasClass("hidden"), true);
      assert.equal(find(SECOND_RANDO_ERROR_FIELD).hasClass("hidden"), false);
      assert.equal(find(THIRD_RANDO_ERROR_FIELD).hasClass("hidden"), false);
    });
    click(".add");
    andThen(function () {
      assert.equal(find(".name-parent-div span").length, 4);
      assert.equal(find(FIRST_NAME_ERROR_FIELD).hasClass("hidden"), false);
      assert.equal(find(SECOND_NAME_ERROR_FIELD).hasClass("hidden"), false);
      assert.equal(find(THIRD_NAME_ERROR_FIELD).hasClass("hidden"), true);
      assert.equal(find(FOURTH_NAME_ERROR_FIELD).hasClass("hidden"), false);
      assert.equal(find(FIRST_RANDO_ERROR_FIELD).hasClass("hidden"), true);
      assert.equal(find(SECOND_RANDO_ERROR_FIELD).hasClass("hidden"), false);
      assert.equal(find(THIRD_RANDO_ERROR_FIELD).hasClass("hidden"), false);
      assert.equal(find(FOURTH_RANDO_ERROR_FIELD).hasClass("hidden"), false);
    });
    fillIn(SECOND_NAME_INPUT, VALID_NAME);
    andThen(function () {
      assert.equal(find(FIRST_NAME_ERROR_FIELD).hasClass("hidden"), false);
      assert.equal(find(SECOND_NAME_ERROR_FIELD).hasClass("hidden"), true);
      assert.equal(find(THIRD_NAME_ERROR_FIELD).hasClass("hidden"), true);
      assert.equal(find(FOURTH_NAME_ERROR_FIELD).hasClass("hidden"), false);
      assert.equal(find(FIRST_RANDO_ERROR_FIELD).hasClass("hidden"), true);
      assert.equal(find(SECOND_RANDO_ERROR_FIELD).hasClass("hidden"), false);
      assert.equal(find(THIRD_RANDO_ERROR_FIELD).hasClass("hidden"), false);
      assert.equal(find(FOURTH_RANDO_ERROR_FIELD).hasClass("hidden"), false);
    });
    click(".remove:eq(2)");
    andThen(function () {
      assert.equal(find(".name-parent-div span").length, 3);
      assert.equal(find(FIRST_NAME_ERROR_FIELD).hasClass("hidden"), false);
      assert.equal(find(SECOND_NAME_ERROR_FIELD).hasClass("hidden"), true);
      assert.equal(find(THIRD_NAME_ERROR_FIELD).hasClass("hidden"), false);
      assert.equal(find(FIRST_RANDO_ERROR_FIELD).hasClass("hidden"), true);
      assert.equal(find(SECOND_RANDO_ERROR_FIELD).hasClass("hidden"), false);
      assert.equal(find(THIRD_RANDO_ERROR_FIELD).hasClass("hidden"), false);
    });
    fillIn(SECOND_NAME_INPUT, INVALID_NAME);
    fillIn(FIRST_RANDO_INPUT, INVALID_RANDO);
    andThen(function () {
      assert.equal(find(".name-parent-div span").length, 3);
      assert.equal(find(FIRST_NAME_ERROR_FIELD).hasClass("hidden"), false);
      assert.equal(find(SECOND_NAME_ERROR_FIELD).hasClass("hidden"), false);
      assert.equal(find(THIRD_NAME_ERROR_FIELD).hasClass("hidden"), false);
      assert.equal(find(FIRST_RANDO_ERROR_FIELD).hasClass("hidden"), false);
      assert.equal(find(SECOND_RANDO_ERROR_FIELD).hasClass("hidden"), false);
      assert.equal(find(THIRD_RANDO_ERROR_FIELD).hasClass("hidden"), false);
    });
    fillIn(SECOND_NAME_INPUT, VALID_NAME);
    fillIn(FIRST_RANDO_INPUT, VALID_RANDO);
    andThen(function () {
      assert.equal(find(".name-parent-div span").length, 3);
      assert.equal(find(FIRST_NAME_ERROR_FIELD).hasClass("hidden"), false);
      assert.equal(find(SECOND_NAME_ERROR_FIELD).hasClass("hidden"), true);
      assert.equal(find(THIRD_NAME_ERROR_FIELD).hasClass("hidden"), false);
      assert.equal(find(FIRST_RANDO_ERROR_FIELD).hasClass("hidden"), true);
      assert.equal(find(SECOND_RANDO_ERROR_FIELD).hasClass("hidden"), false);
      assert.equal(find(THIRD_RANDO_ERROR_FIELD).hasClass("hidden"), false);
    });
    fillIn(FIRST_NAME_INPUT, VALID_NAME);
    fillIn(THIRD_NAME_INPUT, VALID_NAME);
    fillIn(SECOND_RANDO_INPUT, VALID_RANDO);
    fillIn(THIRD_RANDO_INPUT, VALID_RANDO);
    click(SAVE_BUTTON);
    andThen(function () {
      assert.equal(currentURL(), "/success");
    });
  });

  qunit.test("xxx removing invalid models from array will allow success page", function (assert) {
    visit("/multi");
    andThen(function () {
      assert.equal(find(FIRST_NAME_ERROR_FIELD).hasClass("hidden"), true);
      assert.equal(find(SECOND_NAME_ERROR_FIELD).hasClass("hidden"), true);
      assert.equal(find(THIRD_NAME_ERROR_FIELD).hasClass("hidden"), true);
      assert.equal(find(FIRST_RANDO_ERROR_FIELD).hasClass("hidden"), true);
      assert.equal(find(SECOND_RANDO_ERROR_FIELD).hasClass("hidden"), true);
      assert.equal(find(THIRD_RANDO_ERROR_FIELD).hasClass("hidden"), true);
    });
    fillIn(FIRST_NAME_INPUT, VALID_NAME);
    fillIn(FIRST_RANDO_INPUT, VALID_RANDO);
    click(SAVE_BUTTON);
    andThen(function () {
      assert.equal(find(".name-parent-div span").length, 3);
      assert.equal(currentURL(), "/multi");
      assert.equal(find(FIRST_NAME_ERROR_FIELD).hasClass("hidden"), true);
      assert.equal(find(SECOND_NAME_ERROR_FIELD).hasClass("hidden"), false);
      assert.equal(find(THIRD_NAME_ERROR_FIELD).hasClass("hidden"), false);
      assert.equal(find(FIRST_RANDO_ERROR_FIELD).hasClass("hidden"), true);
      assert.equal(find(SECOND_RANDO_ERROR_FIELD).hasClass("hidden"), false);
      assert.equal(find(THIRD_RANDO_ERROR_FIELD).hasClass("hidden"), false);
    });
    click(".remove:eq(2)");
    click(".remove:eq(1)");
    andThen(function () {
      assert.equal(find(".name-parent-div span").length, 1);
      assert.equal(find(FIRST_NAME_ERROR_FIELD).hasClass("hidden"), true);
      assert.equal(find(FIRST_RANDO_ERROR_FIELD).hasClass("hidden"), true);
    });
    click(SAVE_BUTTON);
    andThen(function () {
      assert.equal(currentURL(), "/success");
    });
  });

});
define('dummy/tests/acceptance/array-form-validation-test.jshint', function () {

  'use strict';

  module('JSHint - acceptance');
  test('acceptance/array-form-validation-test.js should pass jshint', function() { 
    ok(true, 'acceptance/array-form-validation-test.js should pass jshint.'); 
  });

});
define('dummy/tests/acceptance/form-validation-test', ['ember', 'dummy/tests/helpers/start-app', 'qunit'], function (Ember, startApp, qunit) {

    'use strict';

    var application;

    var SAVE_BUTTON = "button.save";
    var NAME_ERROR_FIELD = ".name-parent-div span";
    var ZIPCODE_ERROR_FIELD = ".zipcode-parent-div span";
    var EMAIL_ERROR_FIELD = ".email-parent-div span";
    var RANDO_ERROR_FIELD = ".rando-parent-div span";
    var RADEO_ERROR_FIELD = ".radeo-parent-div span";
    var THING_ERROR_FIELD = ".thing-parent-div span";
    var TOS_ERROR_FIELD = ".tos-parent-div span";

    var NAME_INPUT = ".name-parent-div input";
    var ZIPCODE_INPUT = ".zipcode-parent-div input";
    var EMAIL_INPUT = ".email-parent-div input";
    var RANDO_INPUT = ".rando-parent-div input";
    var RADEO_BUTTON_ONE = ".radio-button-one input";
    var RADEO_BUTTON_TWO = ".radio-button-two input";
    var THING_SELECTBOX = ".thing-parent-div select";
    var TOS_CHECKBOX = ".tos-parent-div input";

    var VALID_NAME = "x";
    var VALID_ZIPCODE = "52601";
    var VALID_EMAIL = "hi@hi.com";
    var VALID_RANDO = "1";
    var VALID_THING = 1;

    qunit.module("Acceptance: Form Validation", {
        setup: function setup() {
            application = startApp['default']();
        },
        teardown: function teardown() {
            Ember['default'].run(application, "destroy");
        }
    });

    qunit.test("clicking save will transition to success when each field is valid", function (assert) {
        visit("/");
        fillIn(NAME_INPUT, VALID_NAME);
        fillIn(ZIPCODE_INPUT, VALID_ZIPCODE);
        fillIn(EMAIL_INPUT, VALID_EMAIL);
        fillIn(RANDO_INPUT, VALID_RANDO);
        fillIn(THING_SELECTBOX, VALID_THING);
        click(TOS_CHECKBOX);
        click(RADEO_BUTTON_ONE);
        click(SAVE_BUTTON);
        andThen(function () {
            assert.equal(currentURL(), "/success");
        });
    });

    qunit.test("clicking save will not transition to success when only the last field is valid", function (assert) {
        visit("/");
        click(TOS_CHECKBOX);
        click(SAVE_BUTTON);
        andThen(function () {
            assert.equal(currentURL(), "/");
        });
        fillIn(NAME_INPUT, VALID_NAME);
        fillIn(ZIPCODE_INPUT, VALID_ZIPCODE);
        fillIn(EMAIL_INPUT, VALID_EMAIL);
        fillIn(RANDO_INPUT, VALID_RANDO);
        fillIn(THING_SELECTBOX, VALID_THING);
        click(RADEO_BUTTON_ONE);
        click(SAVE_BUTTON);
        andThen(function () {
            assert.equal(currentURL(), "/success");
        });
    });

    qunit.test("string based inputs with default validation will not accept empty string as valid", function (assert) {
        visit("/");
        andThen(function () {
            assert.equal(find(NAME_ERROR_FIELD).hasClass("hidden"), true);
        });
        fillIn(NAME_INPUT, " ");
        andThen(function () {
            assert.equal(find(NAME_ERROR_FIELD).hasClass("hidden"), false);
        });
        fillIn(NAME_INPUT, VALID_NAME);
        andThen(function () {
            assert.equal(find(NAME_ERROR_FIELD).hasClass("hidden"), true);
        });
    });

    qunit.test("clicking save will fire each validation", function (assert) {
        visit("/");
        andThen(function () {
            assert.equal(currentURL(), "/");
            assert.equal(find(NAME_ERROR_FIELD).hasClass("hidden"), true);
            assert.equal(find(ZIPCODE_ERROR_FIELD).hasClass("hidden"), true);
            assert.equal(find(EMAIL_ERROR_FIELD).hasClass("hidden"), true);
            assert.equal(find(RANDO_ERROR_FIELD).hasClass("hidden"), true);
            assert.equal(find(RADEO_ERROR_FIELD).hasClass("hidden"), true);
            assert.equal(find(THING_ERROR_FIELD).hasClass("hidden"), true);
            assert.equal(find(TOS_ERROR_FIELD).hasClass("hidden"), true);
        });
        click(SAVE_BUTTON);
        andThen(function () {
            assert.equal(currentURL(), "/");
            assert.equal(find(NAME_ERROR_FIELD).hasClass("hidden"), false);
            assert.equal(find(ZIPCODE_ERROR_FIELD).hasClass("hidden"), false);
            assert.equal(find(EMAIL_ERROR_FIELD).hasClass("hidden"), false);
            assert.equal(find(RANDO_ERROR_FIELD).hasClass("hidden"), false);
            assert.equal(find(RADEO_ERROR_FIELD).hasClass("hidden"), false);
            assert.equal(find(THING_ERROR_FIELD).hasClass("hidden"), false);
            assert.equal(find(TOS_ERROR_FIELD).hasClass("hidden"), false);
        });
    });

    qunit.test("component will render with the correct text and css class", function (assert) {
        visit("/");
        click(SAVE_BUTTON);
        andThen(function () {
            assert.equal(currentURL(), "/");
            assert.equal(find(NAME_ERROR_FIELD).hasClass("red"), true);
            assert.equal(find(EMAIL_ERROR_FIELD).hasClass("blue"), true);
            assert.equal(find(NAME_ERROR_FIELD).text(), "invalid name");
            assert.equal(find(ZIPCODE_ERROR_FIELD).text(), "invalid zipcode");
            assert.equal(find(EMAIL_ERROR_FIELD).text(), "invalid email");
            assert.equal(find(RANDO_ERROR_FIELD).text(), "invalid rando");
            assert.equal(find(RADEO_ERROR_FIELD).text(), "invalid radeo");
            assert.equal(find(THING_ERROR_FIELD).text(), "invalid thing");
            assert.equal(find(TOS_ERROR_FIELD).text(), "invalid tos");
        });
    });

    qunit.test("when inputs are showing errors they turn hidden when field is correctly entered", function (assert) {
        visit("/");
        andThen(function () {
            assert.equal(find(NAME_ERROR_FIELD).hasClass("hidden"), true);
            assert.equal(find(ZIPCODE_ERROR_FIELD).hasClass("hidden"), true);
            assert.equal(find(EMAIL_ERROR_FIELD).hasClass("hidden"), true);
            assert.equal(find(RANDO_ERROR_FIELD).hasClass("hidden"), true);
            assert.equal(find(RADEO_ERROR_FIELD).hasClass("hidden"), true);
            assert.equal(find(THING_ERROR_FIELD).hasClass("hidden"), true);
            assert.equal(find(TOS_ERROR_FIELD).hasClass("hidden"), true);
        });
        click(SAVE_BUTTON);
        fillIn(NAME_INPUT, VALID_NAME);
        andThen(function () {
            assert.equal(find(NAME_ERROR_FIELD).hasClass("hidden"), true);
            assert.equal(find(ZIPCODE_ERROR_FIELD).hasClass("hidden"), false);
            assert.equal(find(EMAIL_ERROR_FIELD).hasClass("hidden"), false);
            assert.equal(find(RANDO_ERROR_FIELD).hasClass("hidden"), false);
            assert.equal(find(RADEO_ERROR_FIELD).hasClass("hidden"), false);
            assert.equal(find(THING_ERROR_FIELD).hasClass("hidden"), false);
            assert.equal(find(TOS_ERROR_FIELD).hasClass("hidden"), false);
        });
        fillIn(ZIPCODE_INPUT, VALID_ZIPCODE);
        andThen(function () {
            assert.equal(find(NAME_ERROR_FIELD).hasClass("hidden"), true);
            assert.equal(find(ZIPCODE_ERROR_FIELD).hasClass("hidden"), true);
            assert.equal(find(EMAIL_ERROR_FIELD).hasClass("hidden"), false);
            assert.equal(find(RANDO_ERROR_FIELD).hasClass("hidden"), false);
            assert.equal(find(RADEO_ERROR_FIELD).hasClass("hidden"), false);
            assert.equal(find(THING_ERROR_FIELD).hasClass("hidden"), false);
            assert.equal(find(TOS_ERROR_FIELD).hasClass("hidden"), false);
        });
        fillIn(EMAIL_INPUT, VALID_EMAIL);
        andThen(function () {
            assert.equal(find(NAME_ERROR_FIELD).hasClass("hidden"), true);
            assert.equal(find(ZIPCODE_ERROR_FIELD).hasClass("hidden"), true);
            assert.equal(find(EMAIL_ERROR_FIELD).hasClass("hidden"), true);
            assert.equal(find(RANDO_ERROR_FIELD).hasClass("hidden"), false);
            assert.equal(find(RADEO_ERROR_FIELD).hasClass("hidden"), false);
            assert.equal(find(THING_ERROR_FIELD).hasClass("hidden"), false);
            assert.equal(find(TOS_ERROR_FIELD).hasClass("hidden"), false);
        });
        fillIn(RANDO_INPUT, VALID_RANDO);
        andThen(function () {
            assert.equal(find(NAME_ERROR_FIELD).hasClass("hidden"), true);
            assert.equal(find(ZIPCODE_ERROR_FIELD).hasClass("hidden"), true);
            assert.equal(find(EMAIL_ERROR_FIELD).hasClass("hidden"), true);
            assert.equal(find(RANDO_ERROR_FIELD).hasClass("hidden"), true);
            assert.equal(find(RADEO_ERROR_FIELD).hasClass("hidden"), false);
            assert.equal(find(THING_ERROR_FIELD).hasClass("hidden"), false);
            assert.equal(find(TOS_ERROR_FIELD).hasClass("hidden"), false);
        });
        click(RADEO_BUTTON_ONE);
        andThen(function () {
            assert.equal(find(NAME_ERROR_FIELD).hasClass("hidden"), true);
            assert.equal(find(ZIPCODE_ERROR_FIELD).hasClass("hidden"), true);
            assert.equal(find(EMAIL_ERROR_FIELD).hasClass("hidden"), true);
            assert.equal(find(RANDO_ERROR_FIELD).hasClass("hidden"), true);
            assert.equal(find(RADEO_ERROR_FIELD).hasClass("hidden"), true);
            assert.equal(find(THING_ERROR_FIELD).hasClass("hidden"), false);
            assert.equal(find(TOS_ERROR_FIELD).hasClass("hidden"), false);
        });
        fillIn(THING_SELECTBOX, VALID_THING);
        andThen(function () {
            assert.equal(find(NAME_ERROR_FIELD).hasClass("hidden"), true);
            assert.equal(find(ZIPCODE_ERROR_FIELD).hasClass("hidden"), true);
            assert.equal(find(EMAIL_ERROR_FIELD).hasClass("hidden"), true);
            assert.equal(find(RANDO_ERROR_FIELD).hasClass("hidden"), true);
            assert.equal(find(RADEO_ERROR_FIELD).hasClass("hidden"), true);
            assert.equal(find(THING_ERROR_FIELD).hasClass("hidden"), true);
            assert.equal(find(TOS_ERROR_FIELD).hasClass("hidden"), false);
        });
        click(TOS_CHECKBOX);
        andThen(function () {
            assert.equal(find(NAME_ERROR_FIELD).hasClass("hidden"), true);
            assert.equal(find(ZIPCODE_ERROR_FIELD).hasClass("hidden"), true);
            assert.equal(find(EMAIL_ERROR_FIELD).hasClass("hidden"), true);
            assert.equal(find(RANDO_ERROR_FIELD).hasClass("hidden"), true);
            assert.equal(find(RADEO_ERROR_FIELD).hasClass("hidden"), true);
            assert.equal(find(THING_ERROR_FIELD).hasClass("hidden"), true);
            assert.equal(find(TOS_ERROR_FIELD).hasClass("hidden"), true);
        });
    });

    qunit.test("inputs with default validation start working without submit firing", function (assert) {
        visit("/");
        andThen(function () {
            assert.equal(find(NAME_ERROR_FIELD).hasClass("hidden"), true);
        });
        fillIn(NAME_INPUT, VALID_NAME);
        andThen(function () {
            assert.equal(find(NAME_ERROR_FIELD).hasClass("hidden"), true);
        });
        fillIn(NAME_INPUT, "");
        andThen(function () {
            assert.equal(find(NAME_ERROR_FIELD).hasClass("hidden"), false);
        });
        fillIn(NAME_INPUT, VALID_NAME);
        andThen(function () {
            assert.equal(find(NAME_ERROR_FIELD).hasClass("hidden"), true);
        });
    });

    qunit.test("inputs with regex validation start working without submit firing", function (assert) {
        visit("/");
        andThen(function () {
            assert.equal(find(ZIPCODE_ERROR_FIELD).hasClass("hidden"), true);
        });
        fillIn(ZIPCODE_INPUT, VALID_ZIPCODE);
        andThen(function () {
            assert.equal(find(ZIPCODE_ERROR_FIELD).hasClass("hidden"), true);
        });
        fillIn(ZIPCODE_INPUT, "");
        andThen(function () {
            assert.equal(find(ZIPCODE_ERROR_FIELD).hasClass("hidden"), false);
        });
        fillIn(ZIPCODE_INPUT, "3001");
        andThen(function () {
            assert.equal(find(ZIPCODE_ERROR_FIELD).hasClass("hidden"), false);
        });
        fillIn(ZIPCODE_INPUT, VALID_ZIPCODE);
        andThen(function () {
            assert.equal(find(ZIPCODE_ERROR_FIELD).hasClass("hidden"), true);
        });
    });

    qunit.test("inputs with regex validation will not work without submit when delay option set", function (assert) {
        visit("/");
        andThen(function () {
            assert.equal(find(EMAIL_ERROR_FIELD).hasClass("hidden"), true);
        });
        fillIn(EMAIL_INPUT, VALID_EMAIL);
        andThen(function () {
            assert.equal(find(EMAIL_ERROR_FIELD).hasClass("hidden"), true);
        });
        fillIn(EMAIL_INPUT, "");
        andThen(function () {
            assert.equal(find(EMAIL_ERROR_FIELD).hasClass("hidden"), true);
        });
        click(SAVE_BUTTON);
        andThen(function () {
            assert.equal(find(EMAIL_ERROR_FIELD).hasClass("hidden"), false);
        });
        fillIn(EMAIL_INPUT, VALID_EMAIL);
        andThen(function () {
            assert.equal(find(EMAIL_ERROR_FIELD).hasClass("hidden"), true);
        });
        fillIn(EMAIL_INPUT, "hi");
        andThen(function () {
            assert.equal(find(EMAIL_ERROR_FIELD).hasClass("hidden"), false);
        });
        fillIn(EMAIL_INPUT, VALID_EMAIL);
        andThen(function () {
            assert.equal(find(EMAIL_ERROR_FIELD).hasClass("hidden"), true);
        });
    });

    qunit.test("inputs with default validation will not trip validation when they are tabbed into", function (assert) {
        visit("/");
        andThen(function () {
            assert.equal(find(ZIPCODE_ERROR_FIELD).hasClass("hidden"), true);
        });
        triggerEvent(ZIPCODE_INPUT, "dblclick");
        triggerEvent(ZIPCODE_INPUT, "blur");
        andThen(function () {
            assert.equal(find(ZIPCODE_ERROR_FIELD).hasClass("hidden"), true);
        });
        fillIn(ZIPCODE_INPUT, "5003");
        triggerEvent(ZIPCODE_INPUT, "blur");
        andThen(function () {
            assert.equal(find(ZIPCODE_ERROR_FIELD).hasClass("hidden"), false);
        });
        fillIn(ZIPCODE_INPUT, "12345");
        triggerEvent(ZIPCODE_INPUT, "blur");
        andThen(function () {
            assert.equal(find(ZIPCODE_ERROR_FIELD).hasClass("hidden"), true);
        });
    });

    qunit.test("inputs with function validation start working without submit firing", function (assert) {
        visit("/");
        andThen(function () {
            assert.equal(find(RANDO_ERROR_FIELD).hasClass("hidden"), true);
        });
        fillIn(RANDO_INPUT, VALID_RANDO);
        andThen(function () {
            assert.equal(find(RANDO_ERROR_FIELD).hasClass("hidden"), true);
        });
        fillIn(RANDO_INPUT, "7");
        andThen(function () {
            assert.equal(find(RANDO_ERROR_FIELD).hasClass("hidden"), false);
        });
        fillIn(RANDO_INPUT, VALID_RANDO);
        andThen(function () {
            assert.equal(find(RANDO_ERROR_FIELD).hasClass("hidden"), true);
        });
    });

    qunit.test("number based inputs with default validation will validate correctly", function (assert) {
        visit("/");
        andThen(function () {
            assert.equal(find(RADEO_ERROR_FIELD).hasClass("hidden"), true);
        });
        click(SAVE_BUTTON);
        andThen(function () {
            assert.equal(find(RADEO_ERROR_FIELD).hasClass("hidden"), false);
        });
        click(RADEO_BUTTON_ONE);
        andThen(function () {
            assert.equal(find(RADEO_ERROR_FIELD).hasClass("hidden"), true);
        });
        click(RADEO_BUTTON_TWO);
        andThen(function () {
            assert.equal(find(RADEO_ERROR_FIELD).hasClass("hidden"), true);
        });
    });

    qunit.test("model bound selectbox with default validation will validate correctly", function (assert) {
        visit("/");
        andThen(function () {
            assert.equal(find(THING_ERROR_FIELD).hasClass("hidden"), true);
        });
        click(SAVE_BUTTON);
        andThen(function () {
            assert.equal(find(THING_ERROR_FIELD).hasClass("hidden"), false);
        });
        fillIn(THING_SELECTBOX, VALID_THING);
        andThen(function () {
            assert.equal(find(THING_ERROR_FIELD).hasClass("hidden"), true);
        });
        fillIn(THING_SELECTBOX, "");
        andThen(function () {
            assert.equal(find(THING_ERROR_FIELD).hasClass("hidden"), false);
        });
    });

});
define('dummy/tests/acceptance/form-validation-test.jshint', function () {

  'use strict';

  module('JSHint - acceptance');
  test('acceptance/form-validation-test.js should pass jshint', function() { 
    ok(true, 'acceptance/form-validation-test.js should pass jshint.'); 
  });

});
define('dummy/tests/acceptance/many-array-single-prop-validation-test', ['ember', 'dummy/tests/helpers/start-app', 'qunit'], function (Ember, startApp, qunit) {

  'use strict';

  var application;

  var SAVE_BUTTON = "button.save";
  var VALID_NAME = "123";
  var VALID_NAME_AND_LEN = "1234";

  var FIRST_LEN_ERROR_FIELD = ".name-parent-div:eq(0) span.len";
  var FIRST_BASIC_ERROR_FIELD = ".name-parent-div:eq(0) span.basic";
  var FIRST_NAME_INPUT = ".name-parent-div:eq(0) input";

  var SECOND_LEN_ERROR_FIELD = ".name-parent-div:eq(1) span.len";
  var SECOND_BASIC_ERROR_FIELD = ".name-parent-div:eq(1) span.basic";
  var SECOND_NAME_INPUT = ".name-parent-div:eq(1) input";

  qunit.module("Acceptance: Many Array Single Prop Validation", {
    setup: function setup() {
      application = startApp['default']();
    },
    teardown: function teardown() {
      Ember['default'].run(application, "destroy");
    }
  });

  qunit.test("validateEach will pull named validators when supplied", function (assert) {
    visit("/many");
    andThen(function () {
      assert.equal(find(FIRST_LEN_ERROR_FIELD).hasClass("hidden"), true);
      assert.equal(find(SECOND_LEN_ERROR_FIELD).hasClass("hidden"), true);
      assert.equal(find(FIRST_BASIC_ERROR_FIELD).hasClass("hidden"), true);
      assert.equal(find(SECOND_BASIC_ERROR_FIELD).hasClass("hidden"), true);
    });
    click(SAVE_BUTTON);
    andThen(function () {
      assert.equal(find(FIRST_LEN_ERROR_FIELD).hasClass("hidden"), false);
      assert.equal(find(SECOND_LEN_ERROR_FIELD).hasClass("hidden"), false);
      assert.equal(find(FIRST_BASIC_ERROR_FIELD).hasClass("hidden"), false);
      assert.equal(find(SECOND_BASIC_ERROR_FIELD).hasClass("hidden"), false);
    });
    fillIn(SECOND_NAME_INPUT, VALID_NAME);
    andThen(function () {
      assert.equal(find(FIRST_LEN_ERROR_FIELD).hasClass("hidden"), false);
      assert.equal(find(SECOND_LEN_ERROR_FIELD).hasClass("hidden"), false);
      assert.equal(find(FIRST_BASIC_ERROR_FIELD).hasClass("hidden"), false);
      assert.equal(find(SECOND_BASIC_ERROR_FIELD).hasClass("hidden"), true);
    });
    fillIn(FIRST_NAME_INPUT, VALID_NAME);
    andThen(function () {
      assert.equal(find(FIRST_LEN_ERROR_FIELD).hasClass("hidden"), false);
      assert.equal(find(SECOND_LEN_ERROR_FIELD).hasClass("hidden"), false);
      assert.equal(find(FIRST_BASIC_ERROR_FIELD).hasClass("hidden"), true);
      assert.equal(find(SECOND_BASIC_ERROR_FIELD).hasClass("hidden"), true);
    });
    fillIn(SECOND_NAME_INPUT, VALID_NAME_AND_LEN);
    andThen(function () {
      assert.equal(find(FIRST_LEN_ERROR_FIELD).hasClass("hidden"), false);
      assert.equal(find(SECOND_LEN_ERROR_FIELD).hasClass("hidden"), true);
      assert.equal(find(FIRST_BASIC_ERROR_FIELD).hasClass("hidden"), true);
      assert.equal(find(SECOND_BASIC_ERROR_FIELD).hasClass("hidden"), true);
    });
    fillIn(FIRST_NAME_INPUT, VALID_NAME_AND_LEN);
    andThen(function () {
      assert.equal(find(FIRST_LEN_ERROR_FIELD).hasClass("hidden"), true);
      assert.equal(find(SECOND_LEN_ERROR_FIELD).hasClass("hidden"), true);
      assert.equal(find(FIRST_BASIC_ERROR_FIELD).hasClass("hidden"), true);
      assert.equal(find(SECOND_BASIC_ERROR_FIELD).hasClass("hidden"), true);
    });
    click(SAVE_BUTTON);
    andThen(function () {
      assert.equal(currentURL(), "/success");
    });
  });

});
define('dummy/tests/acceptance/many-array-single-prop-validation-test.jshint', function () {

  'use strict';

  module('JSHint - acceptance');
  test('acceptance/many-array-single-prop-validation-test.js should pass jshint', function() { 
    ok(true, 'acceptance/many-array-single-prop-validation-test.js should pass jshint.'); 
  });

});
define('dummy/tests/acceptance/other-array-form-validation-test', ['ember', 'dummy/tests/helpers/start-app', 'qunit'], function (Ember, startApp, qunit) {

  'use strict';

  var application;

  var SAVE_BUTTON = "button.save";
  var ADD_BUTTON = "button.add";
  var VALID_DISPLAY_NAME = "x";
  var INVALID_DISPLAY_NAME = "";

  var FIRST_DISPLAY_NAME_ERROR_FIELD = ".display-name-parent-div:eq(0) span";
  var FIRST_TOS_ERROR_FIELD = ".tos-parent-div:eq(0) span";
  var FIRST_DISPLAY_NAME_INPUT = ".display-name-parent-div:eq(0) input";
  var FIRST_TOS_INPUT = ".tos-parent-div:eq(0) input";

  var SECOND_DISPLAY_NAME_ERROR_FIELD = ".display-name-parent-div:eq(1) span";
  var SECOND_TOS_ERROR_FIELD = ".tos-parent-div:eq(1) span";
  var SECOND_DISPLAY_NAME_INPUT = ".display-name-parent-div:eq(1) input";
  var SECOND_TOS_INPUT = ".tos-parent-div:eq(1) input";

  var THIRD_DISPLAY_NAME_ERROR_FIELD = ".display-name-parent-div:eq(2) span";
  var THIRD_TOS_ERROR_FIELD = ".tos-parent-div:eq(2) span";
  var THIRD_DISPLAY_NAME_INPUT = ".display-name-parent-div:eq(2) input";
  var THIRD_TOS_INPUT = ".tos-parent-div:eq(2) input";

  var FOURTH_DISPLAY_NAME_ERROR_FIELD = ".display-name-parent-div:eq(3) span";
  var FOURTH_TOS_ERROR_FIELD = ".tos-parent-div:eq(3) span";
  var FOURTH_DISPLAY_NAME_INPUT = ".display-name-parent-div:eq(3) input";
  var FOURTH_TOS_INPUT = ".tos-parent-div:eq(3) input";

  qunit.module("Acceptance: Other Array Form Validation", {
    setup: function setup() {
      application = startApp['default']();
    },
    teardown: function teardown() {
      Ember['default'].run(application, "destroy");
    }
  });

  qunit.test("adding and removing elements from the other array will keep validations in sync", function (assert) {
    visit("/other");
    andThen(function () {
      assert.equal(find(FIRST_DISPLAY_NAME_ERROR_FIELD).hasClass("hidden"), true);
      assert.equal(find(SECOND_DISPLAY_NAME_ERROR_FIELD).hasClass("hidden"), true);
      assert.equal(find(THIRD_DISPLAY_NAME_ERROR_FIELD).hasClass("hidden"), true);
      assert.equal(find(FIRST_TOS_ERROR_FIELD).hasClass("hidden"), true);
      assert.equal(find(SECOND_TOS_ERROR_FIELD).hasClass("hidden"), true);
      assert.equal(find(THIRD_TOS_ERROR_FIELD).hasClass("hidden"), true);
    });
    click(SAVE_BUTTON);
    andThen(function () {
      assert.equal(find(FIRST_DISPLAY_NAME_ERROR_FIELD).hasClass("hidden"), false);
      assert.equal(find(SECOND_DISPLAY_NAME_ERROR_FIELD).hasClass("hidden"), false);
      assert.equal(find(THIRD_DISPLAY_NAME_ERROR_FIELD).hasClass("hidden"), false);
      assert.equal(find(FIRST_TOS_ERROR_FIELD).hasClass("hidden"), false);
      assert.equal(find(SECOND_TOS_ERROR_FIELD).hasClass("hidden"), false);
      assert.equal(find(THIRD_TOS_ERROR_FIELD).hasClass("hidden"), false);
    });
    fillIn(THIRD_DISPLAY_NAME_INPUT, VALID_DISPLAY_NAME);
    click(FIRST_TOS_INPUT);
    andThen(function () {
      assert.equal(find(".display-name-parent-div span").length, 3);
      assert.equal(currentURL(), "/other");
      assert.equal(find(FIRST_DISPLAY_NAME_ERROR_FIELD).hasClass("hidden"), false);
      assert.equal(find(SECOND_DISPLAY_NAME_ERROR_FIELD).hasClass("hidden"), false);
      assert.equal(find(THIRD_DISPLAY_NAME_ERROR_FIELD).hasClass("hidden"), true);
      assert.equal(find(FIRST_TOS_ERROR_FIELD).hasClass("hidden"), true);
      assert.equal(find(SECOND_TOS_ERROR_FIELD).hasClass("hidden"), false);
      assert.equal(find(THIRD_TOS_ERROR_FIELD).hasClass("hidden"), false);
    });
    click(".add");
    andThen(function () {
      assert.equal(find(".display-name-parent-div span").length, 4);
      assert.equal(find(FIRST_DISPLAY_NAME_ERROR_FIELD).hasClass("hidden"), false);
      assert.equal(find(SECOND_DISPLAY_NAME_ERROR_FIELD).hasClass("hidden"), false);
      assert.equal(find(THIRD_DISPLAY_NAME_ERROR_FIELD).hasClass("hidden"), true);
      assert.equal(find(FOURTH_DISPLAY_NAME_ERROR_FIELD).hasClass("hidden"), false);
      assert.equal(find(FIRST_TOS_ERROR_FIELD).hasClass("hidden"), true);
      assert.equal(find(SECOND_TOS_ERROR_FIELD).hasClass("hidden"), false);
      assert.equal(find(THIRD_TOS_ERROR_FIELD).hasClass("hidden"), false);
      assert.equal(find(FOURTH_TOS_ERROR_FIELD).hasClass("hidden"), false);
    });
    fillIn(SECOND_DISPLAY_NAME_INPUT, VALID_DISPLAY_NAME);
    andThen(function () {
      assert.equal(find(FIRST_DISPLAY_NAME_ERROR_FIELD).hasClass("hidden"), false);
      assert.equal(find(SECOND_DISPLAY_NAME_ERROR_FIELD).hasClass("hidden"), true);
      assert.equal(find(THIRD_DISPLAY_NAME_ERROR_FIELD).hasClass("hidden"), true);
      assert.equal(find(FOURTH_DISPLAY_NAME_ERROR_FIELD).hasClass("hidden"), false);
      assert.equal(find(FIRST_TOS_ERROR_FIELD).hasClass("hidden"), true);
      assert.equal(find(SECOND_TOS_ERROR_FIELD).hasClass("hidden"), false);
      assert.equal(find(THIRD_TOS_ERROR_FIELD).hasClass("hidden"), false);
      assert.equal(find(FOURTH_TOS_ERROR_FIELD).hasClass("hidden"), false);
    });
    click(".remove:eq(2)");
    andThen(function () {
      assert.equal(find(".display-name-parent-div span").length, 3);
      assert.equal(find(FIRST_DISPLAY_NAME_ERROR_FIELD).hasClass("hidden"), false);
      assert.equal(find(SECOND_DISPLAY_NAME_ERROR_FIELD).hasClass("hidden"), true);
      assert.equal(find(THIRD_DISPLAY_NAME_ERROR_FIELD).hasClass("hidden"), false);
      assert.equal(find(FIRST_TOS_ERROR_FIELD).hasClass("hidden"), true);
      assert.equal(find(SECOND_TOS_ERROR_FIELD).hasClass("hidden"), false);
      assert.equal(find(THIRD_TOS_ERROR_FIELD).hasClass("hidden"), false);
    });
    fillIn(SECOND_DISPLAY_NAME_INPUT, INVALID_DISPLAY_NAME);
    click(FIRST_TOS_INPUT);
    andThen(function () {
      assert.equal(find(".display-name-parent-div span").length, 3);
      assert.equal(find(FIRST_DISPLAY_NAME_ERROR_FIELD).hasClass("hidden"), false);
      assert.equal(find(SECOND_DISPLAY_NAME_ERROR_FIELD).hasClass("hidden"), false);
      assert.equal(find(THIRD_DISPLAY_NAME_ERROR_FIELD).hasClass("hidden"), false);
      assert.equal(find(FIRST_TOS_ERROR_FIELD).hasClass("hidden"), false);
      assert.equal(find(SECOND_TOS_ERROR_FIELD).hasClass("hidden"), false);
      assert.equal(find(THIRD_TOS_ERROR_FIELD).hasClass("hidden"), false);
    });
    fillIn(SECOND_DISPLAY_NAME_INPUT, VALID_DISPLAY_NAME);
    click(FIRST_TOS_INPUT);
    andThen(function () {
      assert.equal(find(".display-name-parent-div span").length, 3);
      assert.equal(find(FIRST_DISPLAY_NAME_ERROR_FIELD).hasClass("hidden"), false);
      assert.equal(find(SECOND_DISPLAY_NAME_ERROR_FIELD).hasClass("hidden"), true);
      assert.equal(find(THIRD_DISPLAY_NAME_ERROR_FIELD).hasClass("hidden"), false);
      assert.equal(find(FIRST_TOS_ERROR_FIELD).hasClass("hidden"), true);
      assert.equal(find(SECOND_TOS_ERROR_FIELD).hasClass("hidden"), false);
      assert.equal(find(THIRD_TOS_ERROR_FIELD).hasClass("hidden"), false);
    });
    fillIn(FIRST_DISPLAY_NAME_INPUT, VALID_DISPLAY_NAME);
    fillIn(THIRD_DISPLAY_NAME_INPUT, VALID_DISPLAY_NAME);
    click(SECOND_TOS_INPUT);
    click(THIRD_TOS_INPUT);
    click(SAVE_BUTTON);
    andThen(function () {
      assert.equal(currentURL(), "/success");
    });
  });

});
define('dummy/tests/acceptance/other-array-form-validation-test.jshint', function () {

  'use strict';

  module('JSHint - acceptance');
  test('acceptance/other-array-form-validation-test.js should pass jshint', function() { 
    ok(true, 'acceptance/other-array-form-validation-test.js should pass jshint.'); 
  });

});
define('dummy/tests/app.jshint', function () {

  'use strict';

  module('JSHint - .');
  test('app.js should pass jshint', function() { 
    ok(true, 'app.js should pass jshint.'); 
  });

});
define('dummy/tests/components/radio-button.jshint', function () {

  'use strict';

  module('JSHint - components');
  test('components/radio-button.js should pass jshint', function() { 
    ok(true, 'components/radio-button.js should pass jshint.'); 
  });

});
define('dummy/tests/controllers/add.jshint', function () {

  'use strict';

  module('JSHint - controllers');
  test('controllers/add.js should pass jshint', function() { 
    ok(true, 'controllers/add.js should pass jshint.'); 
  });

});
define('dummy/tests/controllers/edit.jshint', function () {

  'use strict';

  module('JSHint - controllers');
  test('controllers/edit.js should pass jshint', function() { 
    ok(true, 'controllers/edit.js should pass jshint.'); 
  });

});
define('dummy/tests/controllers/many.jshint', function () {

  'use strict';

  module('JSHint - controllers');
  test('controllers/many.js should pass jshint', function() { 
    ok(true, 'controllers/many.js should pass jshint.'); 
  });

});
define('dummy/tests/controllers/multi.jshint', function () {

  'use strict';

  module('JSHint - controllers');
  test('controllers/multi.js should pass jshint', function() { 
    ok(true, 'controllers/multi.js should pass jshint.'); 
  });

});
define('dummy/tests/controllers/other.jshint', function () {

  'use strict';

  module('JSHint - controllers');
  test('controllers/other.js should pass jshint', function() { 
    ok(true, 'controllers/other.js should pass jshint.'); 
  });

});
define('dummy/tests/helpers/resolver', ['exports', 'ember/resolver', 'dummy/config/environment'], function (exports, Resolver, config) {

  'use strict';

  var resolver = Resolver['default'].create();

  resolver.namespace = {
    modulePrefix: config['default'].modulePrefix,
    podModulePrefix: config['default'].podModulePrefix
  };

  exports['default'] = resolver;

});
define('dummy/tests/helpers/resolver.jshint', function () {

  'use strict';

  module('JSHint - helpers');
  test('helpers/resolver.js should pass jshint', function() { 
    ok(true, 'helpers/resolver.js should pass jshint.'); 
  });

});
define('dummy/tests/helpers/start-app', ['exports', 'ember', 'dummy/app', 'dummy/router', 'dummy/config/environment'], function (exports, Ember, Application, Router, config) {

  'use strict';



  exports['default'] = startApp;
  function startApp(attrs) {
    var application;

    var attributes = Ember['default'].merge({}, config['default'].APP);
    attributes = Ember['default'].merge(attributes, attrs); // use defaults, but you can override;

    Ember['default'].run(function () {
      application = Application['default'].create(attributes);
      application.setupForTesting();
      application.injectTestHelpers();
    });

    return application;
  }

});
define('dummy/tests/helpers/start-app.jshint', function () {

  'use strict';

  module('JSHint - helpers');
  test('helpers/start-app.js should pass jshint', function() { 
    ok(true, 'helpers/start-app.js should pass jshint.'); 
  });

});
define('dummy/tests/models/many.jshint', function () {

  'use strict';

  module('JSHint - models');
  test('models/many.js should pass jshint', function() { 
    ok(true, 'models/many.js should pass jshint.'); 
  });

});
define('dummy/tests/models/other.jshint', function () {

  'use strict';

  module('JSHint - models');
  test('models/other.js should pass jshint', function() { 
    ok(true, 'models/other.js should pass jshint.'); 
  });

});
define('dummy/tests/models/person.jshint', function () {

  'use strict';

  module('JSHint - models');
  test('models/person.js should pass jshint', function() { 
    ok(true, 'models/person.js should pass jshint.'); 
  });

});
define('dummy/tests/router.jshint', function () {

  'use strict';

  module('JSHint - .');
  test('router.js should pass jshint', function() { 
    ok(true, 'router.js should pass jshint.'); 
  });

});
define('dummy/tests/routes/add.jshint', function () {

  'use strict';

  module('JSHint - routes');
  test('routes/add.js should pass jshint', function() { 
    ok(true, 'routes/add.js should pass jshint.'); 
  });

});
define('dummy/tests/routes/edit.jshint', function () {

  'use strict';

  module('JSHint - routes');
  test('routes/edit.js should pass jshint', function() { 
    ok(true, 'routes/edit.js should pass jshint.'); 
  });

});
define('dummy/tests/routes/many.jshint', function () {

  'use strict';

  module('JSHint - routes');
  test('routes/many.js should pass jshint', function() { 
    ok(true, 'routes/many.js should pass jshint.'); 
  });

});
define('dummy/tests/routes/multi.jshint', function () {

  'use strict';

  module('JSHint - routes');
  test('routes/multi.js should pass jshint', function() { 
    ok(true, 'routes/multi.js should pass jshint.'); 
  });

});
define('dummy/tests/routes/other.jshint', function () {

  'use strict';

  module('JSHint - routes');
  test('routes/other.js should pass jshint', function() { 
    ok(true, 'routes/other.js should pass jshint.'); 
  });

});
define('dummy/tests/test-helper', ['dummy/tests/helpers/resolver', 'ember-qunit'], function (resolver, ember_qunit) {

	'use strict';

	ember_qunit.setResolver(resolver['default']);

});
define('dummy/tests/test-helper.jshint', function () {

  'use strict';

  module('JSHint - .');
  test('test-helper.js should pass jshint', function() { 
    ok(true, 'test-helper.js should pass jshint.'); 
  });

});
define('dummy/tests/unit/validation-mixin-test', ['ember', 'qunit', 'ember-cli-simple-store/model', 'ember-cli-simple-validation/mixins/validate'], function (Ember, qunit, ember_cli_simple_store__model, validate) {

    'use strict';

    var Person = ember_cli_simple_store__model.Model.extend({
        name: ember_cli_simple_store__model.attr(),
        email: ember_cli_simple_store__model.attr()
    });

    var controller,
        model = Person.create({ name: "x", email: "hi@hi.com" });

    var FakeController = Ember['default'].Controller.extend(validate.ValidationMixin, {
        nameValidation: validate.validate("model.name"),
        emailValidation: validate.validate("model.email", /\S+@\S+\.\S+/),
        model: model
    });

    qunit.module("Unit: Validation Mixin", {
        setup: function setup() {
            controller = new FakeController();
        },
        teardown: function teardown() {
            controller = null;
        }
    });

    qunit.test("validation will fire when computed validation value is update", function (assert) {
        assert.equal(controller.get("nameValidation"), true);
        model.set("name", "");
        assert.equal(controller.get("nameValidation"), false);
        model.set("name", "x");
        assert.equal(controller.get("nameValidation"), true);
    });

    qunit.test("validate attr without regex option will trim the value by default", function (assert) {
        assert.equal(controller.get("nameValidation"), true);
        model.set("name", "");
        assert.equal(controller.get("nameValidation"), false);
        model.set("name", " ");
        assert.equal(controller.get("nameValidation"), false);
        model.set("name", "x");
        assert.equal(controller.get("nameValidation"), true);
    });

    qunit.test("validate attr with regex will validate using the given pattern", function (assert) {
        assert.equal(controller.get("emailValidation"), true);
        model.set("email", "");
        assert.equal(controller.get("emailValidation"), false);
        model.set("email", "hi@h");
        assert.equal(controller.get("emailValidation"), false);
        model.set("email", "hi@hi.com");
        assert.equal(controller.get("emailValidation"), true);
    });

});
define('dummy/tests/unit/validation-mixin-test.jshint', function () {

  'use strict';

  module('JSHint - unit');
  test('unit/validation-mixin-test.js should pass jshint', function() { 
    ok(true, 'unit/validation-mixin-test.js should pass jshint.'); 
  });

});
/* jshint ignore:start */

/* jshint ignore:end */

/* jshint ignore:start */

define('dummy/config/environment', ['ember'], function(Ember) {
  var prefix = 'dummy';
/* jshint ignore:start */

try {
  var metaName = prefix + '/config/environment';
  var rawConfig = Ember['default'].$('meta[name="' + metaName + '"]').attr('content');
  var config = JSON.parse(unescape(rawConfig));

  return { 'default': config };
}
catch(err) {
  throw new Error('Could not read config from meta tag with name "' + metaName + '".');
}

/* jshint ignore:end */

});

if (runningTests) {
  require("dummy/tests/test-helper");
} else {
  require("dummy/app")["default"].create({"LOG_ACTIVE_GENERATION":false,"LOG_VIEW_LOOKUPS":false,"rootElement":"#ember-testing","name":"ember-cli-simple-validation","version":"0.4.0.16fdbaf2"});
}

/* jshint ignore:end */
//# sourceMappingURL=dummy.map